/* chess-window.c generated by valac 0.52.10, the Vala compiler
 * generated from chess-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2020 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define TYPE_CHESS_WINDOW (chess_window_get_type ())
#define CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_WINDOW, ChessWindow))
#define CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_WINDOW, ChessWindowClass))
#define IS_CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_WINDOW))
#define IS_CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_WINDOW))
#define CHESS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_WINDOW, ChessWindowClass))

typedef struct _ChessWindow ChessWindow;
typedef struct _ChessWindowClass ChessWindowClass;
typedef struct _ChessWindowPrivate ChessWindowPrivate;
typedef enum  {
	CHESS_WINDOW_LAYOUT_MODE_NORMAL,
	CHESS_WINDOW_LAYOUT_MODE_NARROW
} ChessWindowLayoutMode;

#define CHESS_WINDOW_TYPE_LAYOUT_MODE (chess_window_layout_mode_get_type ())

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;

#define TYPE_CHESS_APPLICATION (chess_application_get_type ())
#define CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_APPLICATION, ChessApplication))
#define CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_APPLICATION, ChessApplicationClass))
#define IS_CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_APPLICATION))
#define IS_CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_APPLICATION))
#define CHESS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_APPLICATION, ChessApplicationClass))

typedef struct _ChessApplication ChessApplication;
typedef struct _ChessApplicationClass ChessApplicationClass;
enum  {
	CHESS_WINDOW_0_PROPERTY,
	CHESS_WINDOW_LAYOUT_MODE_PROPERTY,
	CHESS_WINDOW_VIEW_PROPERTY,
	CHESS_WINDOW_SCENE_PROPERTY,
	CHESS_WINDOW_GAME_PROPERTY,
	CHESS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* chess_window_properties[CHESS_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessWindow {
	GtkApplicationWindow parent_instance;
	ChessWindowPrivate * priv;
};

struct _ChessWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _ChessWindowPrivate {
	ChessWindowLayoutMode _layout_mode;
	ChessView* _view;
	ChessApplication* app;
	GtkBox* main_box;
	GtkInfoBar* info_bar;
	GtkLabel* info_bar_label;
	GtkButton* pause_resume_button;
	GtkBox* navigation_box;
	GtkComboBox* history_combo;
	GtkBox* clock_box;
	GtkDrawingArea* white_time_label;
	GtkDrawingArea* black_time_label;
};

struct _Block2Data {
	int _ref_count_;
	ChessWindow* self;
	GtkWidget* widget;
	cairo_t* c;
};

struct _Block3Data {
	int _ref_count_;
	ChessWindow* self;
	ChessWindowLayoutMode value;
};

static gint ChessWindow_private_offset;
static gpointer chess_window_parent_class = NULL;

GType chess_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessWindow, g_object_unref)
GType chess_window_layout_mode_get_type (void) G_GNUC_CONST ;
GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
GType chess_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessApplication, g_object_unref)
ChessWindow* chess_window_new (ChessApplication* app);
ChessWindow* chess_window_construct (GType object_type,
                                     ChessApplication* app);
GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
ChessScene* chess_scene_new (void);
ChessScene* chess_scene_construct (GType object_type);
static void __lambda25_ (ChessWindow* self);
void chess_window_update_history_panel (ChessWindow* self);
static void ___lambda25__chess_scene_changed (ChessScene* _sender,
                                       gpointer self);
ChessView* chess_view_new (ChessScene* scene);
ChessView* chess_view_construct (GType object_type,
                                 ChessScene* scene);
static void chess_window_set_view (ChessWindow* self,
                            ChessView* value);
ChessView* chess_window_get_view (ChessWindow* self);
void chess_window_update_pause_resume_button (ChessWindow* self);
static void chess_window_draw_white_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_draw_black_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_window_state_changed_cb (ChessWindow* self);
static void _chess_window_window_state_changed_cb_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
ChessWindowLayoutMode chess_window_get_layout_mode (ChessWindow* self);
static void chess_window_set_layout_mode (ChessWindow* self,
                                   ChessWindowLayoutMode value);
void chess_window_update_game_status (ChessWindow* self,
                                      const gchar* title,
                                      const gchar* info);
gchar* chess_application_compute_current_title (ChessApplication* self);
gchar* chess_application_compute_status_info (ChessApplication* self);
ChessScene* chess_window_get_scene (ChessWindow* self);
ChessGame* chess_scene_get_game (ChessScene* self);
ChessGame* chess_window_get_game (ChessWindow* self);
gint chess_scene_get_move_number (ChessScene* self);
void chess_application_enable_action (ChessApplication* self,
                                      const gchar* name);
#define HISTORY_GO_FIRST_ACTION_NAME "go-first"
void chess_application_disable_action (ChessApplication* self,
                                       const gchar* name);
#define HISTORY_GO_PREVIOUS_ACTION_NAME "go-previous"
#define HISTORY_GO_NEXT_ACTION_NAME "go-next"
#define HISTORY_GO_LAST_ACTION_NAME "go-last"
void chess_window_set_move_text (ChessWindow* self,
                                 GtkTreeIter* iter,
                                 ChessMove* move);
void chess_window_set_clock_visible (ChessWindow* self,
                                     gboolean visible);
static gint chess_window_compute_time_label_width_request (ChessWindow* self,
                                                    cairo_t* c);
static void chess_window_draw_time (ChessWindow* self,
                             GtkWidget* widget,
                             cairo_t* c,
                             gint width,
                             gint height,
                             const gchar* text,
                             gdouble* fg,
                             gint fg_length1,
                             gdouble* bg,
                             gint bg_length1);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda26_ (Block2Data* _data2_);
static gboolean ____lambda26__gsource_func (gpointer self);
static gchar* chess_window_make_clock_text (ChessWindow* self,
                                     ChessClock* clock,
                                     Color color);
static void chess_window_history_combo_changed_cb (ChessWindow* self,
                                            GtkComboBox* combo);
void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
static void _chess_window_history_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self);
const gchar* chess_scene_get_move_format (ChessScene* self);
void chess_window_start_game (ChessWindow* self);
static void ___lambda14_ (ChessWindow* self);
static void ____lambda14__chess_clock_tick (ChessClock* _sender,
                                     gpointer self);
void chess_window_move (ChessWindow* self,
                        ChessMove* m);
void chess_window_undo (ChessWindow* self);
void chess_window_end_game (ChessWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean _chess_window_layout_mode___lambda23_ (Block3Data* _data3_);
static gboolean __chess_window_layout_mode___lambda23__gsource_func (gpointer self);
ChessScene* chess_view_get_scene (ChessView* self);
static void chess_window_finalize (GObject * obj);
static GType chess_window_get_type_once (void);
static void _vala_chess_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chess_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
chess_window_get_instance_private (ChessWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ChessWindow_private_offset);
}

static GType
chess_window_layout_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{CHESS_WINDOW_LAYOUT_MODE_NORMAL, "CHESS_WINDOW_LAYOUT_MODE_NORMAL", "normal"}, {CHESS_WINDOW_LAYOUT_MODE_NARROW, "CHESS_WINDOW_LAYOUT_MODE_NARROW", "narrow"}, {0, NULL, NULL}};
	GType chess_window_layout_mode_type_id;
	chess_window_layout_mode_type_id = g_enum_register_static ("ChessWindowLayoutMode", values);
	return chess_window_layout_mode_type_id;
}

GType
chess_window_layout_mode_get_type (void)
{
	static volatile gsize chess_window_layout_mode_type_id__volatile = 0;
	if (g_once_init_enter (&chess_window_layout_mode_type_id__volatile)) {
		GType chess_window_layout_mode_type_id;
		chess_window_layout_mode_type_id = chess_window_layout_mode_get_type_once ();
		g_once_init_leave (&chess_window_layout_mode_type_id__volatile, chess_window_layout_mode_type_id);
	}
	return chess_window_layout_mode_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 78 "../src/chess-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 289 "chess-window.c"
}

static void
__lambda25_ (ChessWindow* self)
{
#line 81 "../src/chess-window.vala"
	chess_window_update_history_panel (self);
#line 297 "chess-window.c"
}

static void
___lambda25__chess_scene_changed (ChessScene* _sender,
                                  gpointer self)
{
#line 81 "../src/chess-window.vala"
	__lambda25_ ((ChessWindow*) self);
#line 306 "chess-window.c"
}

static void
_chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 88 "../src/chess-window.vala"
	chess_window_draw_white_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 318 "chess-window.c"
}

static void
_chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 89 "../src/chess-window.vala"
	chess_window_draw_black_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 330 "chess-window.c"
}

static void
_chess_window_window_state_changed_cb_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 91 "../src/chess-window.vala"
	chess_window_window_state_changed_cb ((ChessWindow*) self);
#line 340 "chess-window.c"
}

ChessWindow*
chess_window_construct (GType object_type,
                        ChessApplication* app)
{
	ChessWindow * self = NULL;
	ChessApplication* _tmp0_;
	ChessScene* scene = NULL;
	ChessScene* _tmp1_;
	ChessView* _tmp2_;
	ChessView* _tmp3_;
	GtkBox* _tmp4_;
	ChessView* _tmp5_;
	GtkInfoBar* _tmp6_;
	GtkDrawingArea* _tmp7_;
	GtkDrawingArea* _tmp8_;
#line 76 "../src/chess-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 76 "../src/chess-window.vala"
	self = (ChessWindow*) g_object_new (object_type, NULL);
#line 78 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 78 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 78 "../src/chess-window.vala"
	self->priv->app = _tmp0_;
#line 80 "../src/chess-window.vala"
	_tmp1_ = chess_scene_new ();
#line 80 "../src/chess-window.vala"
	scene = _tmp1_;
#line 81 "../src/chess-window.vala"
	g_signal_connect_object (scene, "changed", (GCallback) ___lambda25__chess_scene_changed, self, 0);
#line 83 "../src/chess-window.vala"
	_tmp2_ = chess_view_new (scene);
#line 83 "../src/chess-window.vala"
	g_object_ref_sink (_tmp2_);
#line 83 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 83 "../src/chess-window.vala"
	chess_window_set_view (self, _tmp3_);
#line 83 "../src/chess-window.vala"
	_g_object_unref0 (_tmp3_);
#line 84 "../src/chess-window.vala"
	_tmp4_ = self->priv->main_box;
#line 84 "../src/chess-window.vala"
	_tmp5_ = self->priv->_view;
#line 84 "../src/chess-window.vala"
	_tmp6_ = self->priv->info_bar;
#line 84 "../src/chess-window.vala"
	gtk_box_insert_child_after (_tmp4_, (GtkWidget*) _tmp5_, (GtkWidget*) _tmp6_);
#line 86 "../src/chess-window.vala"
	chess_window_update_pause_resume_button (self);
#line 88 "../src/chess-window.vala"
	_tmp7_ = self->priv->white_time_label;
#line 88 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp7_, _chess_window_draw_white_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 89 "../src/chess-window.vala"
	_tmp8_ = self->priv->black_time_label;
#line 89 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp8_, _chess_window_draw_black_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 91 "../src/chess-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::default-height", (GCallback) _chess_window_window_state_changed_cb_g_object_notify, self, 0);
#line 92 "../src/chess-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::default-width", (GCallback) _chess_window_window_state_changed_cb_g_object_notify, self, 0);
#line 76 "../src/chess-window.vala"
	_g_object_unref0 (scene);
#line 76 "../src/chess-window.vala"
	return self;
#line 410 "chess-window.c"
}

ChessWindow*
chess_window_new (ChessApplication* app)
{
#line 76 "../src/chess-window.vala"
	return chess_window_construct (TYPE_CHESS_WINDOW, app);
#line 418 "chess-window.c"
}

static void
chess_window_window_state_changed_cb (ChessWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_;
	gint _tmp12_;
#line 95 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "fullscreened", &_tmp1_, NULL);
#line 97 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 97 "../src/chess-window.vala"
	if (_tmp2_) {
#line 97 "../src/chess-window.vala"
		_tmp0_ = TRUE;
#line 443 "chess-window.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 97 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "maximized", &_tmp3_, NULL);
#line 97 "../src/chess-window.vala"
		_tmp4_ = _tmp3_;
#line 97 "../src/chess-window.vala"
		_tmp0_ = _tmp4_;
#line 453 "chess-window.c"
	}
#line 97 "../src/chess-window.vala"
	if (_tmp0_) {
#line 98 "../src/chess-window.vala"
		return;
#line 459 "chess-window.c"
	}
#line 100 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp6_, NULL);
#line 100 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 100 "../src/chess-window.vala"
	if (_tmp7_ == 0) {
#line 100 "../src/chess-window.vala"
		_tmp5_ = TRUE;
#line 469 "chess-window.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 100 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "default-height", &_tmp8_, NULL);
#line 100 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 100 "../src/chess-window.vala"
		_tmp5_ = _tmp9_ == 0;
#line 479 "chess-window.c"
	}
#line 100 "../src/chess-window.vala"
	if (_tmp5_) {
#line 101 "../src/chess-window.vala"
		return;
#line 485 "chess-window.c"
	}
#line 103 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp11_, NULL);
#line 103 "../src/chess-window.vala"
	_tmp12_ = _tmp11_;
#line 103 "../src/chess-window.vala"
	if (_tmp12_ <= 500) {
#line 493 "chess-window.c"
		ChessWindowLayoutMode _tmp13_;
		ChessWindowLayoutMode _tmp14_;
#line 103 "../src/chess-window.vala"
		_tmp13_ = chess_window_get_layout_mode (self);
#line 103 "../src/chess-window.vala"
		_tmp14_ = _tmp13_;
#line 103 "../src/chess-window.vala"
		_tmp10_ = _tmp14_ == CHESS_WINDOW_LAYOUT_MODE_NORMAL;
#line 502 "chess-window.c"
	} else {
#line 103 "../src/chess-window.vala"
		_tmp10_ = FALSE;
#line 506 "chess-window.c"
	}
#line 103 "../src/chess-window.vala"
	if (_tmp10_) {
#line 104 "../src/chess-window.vala"
		chess_window_set_layout_mode (self, CHESS_WINDOW_LAYOUT_MODE_NARROW);
#line 512 "chess-window.c"
	} else {
		gboolean _tmp15_ = FALSE;
		gint _tmp16_;
		gint _tmp17_;
#line 105 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "default-width", &_tmp16_, NULL);
#line 105 "../src/chess-window.vala"
		_tmp17_ = _tmp16_;
#line 105 "../src/chess-window.vala"
		if (_tmp17_ > 500) {
#line 523 "chess-window.c"
			ChessWindowLayoutMode _tmp18_;
			ChessWindowLayoutMode _tmp19_;
#line 105 "../src/chess-window.vala"
			_tmp18_ = chess_window_get_layout_mode (self);
#line 105 "../src/chess-window.vala"
			_tmp19_ = _tmp18_;
#line 105 "../src/chess-window.vala"
			_tmp15_ = _tmp19_ == CHESS_WINDOW_LAYOUT_MODE_NARROW;
#line 532 "chess-window.c"
		} else {
#line 105 "../src/chess-window.vala"
			_tmp15_ = FALSE;
#line 536 "chess-window.c"
		}
#line 105 "../src/chess-window.vala"
		if (_tmp15_) {
#line 106 "../src/chess-window.vala"
			chess_window_set_layout_mode (self, CHESS_WINDOW_LAYOUT_MODE_NORMAL);
#line 542 "chess-window.c"
		}
	}
}

void
chess_window_update_game_status (ChessWindow* self,
                                 const gchar* title,
                                 const gchar* info)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp4_ = NULL;
	GtkLabel* _tmp8_;
	GtkInfoBar* _tmp9_;
	GtkLabel* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
#line 109 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/chess-window.vala"
	if (title != NULL) {
#line 563 "chess-window.c"
		gchar* _tmp1_;
#line 111 "../src/chess-window.vala"
		_tmp1_ = g_strdup (title);
#line 111 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 111 "../src/chess-window.vala"
		_tmp0_ = _tmp1_;
#line 571 "chess-window.c"
	} else {
		ChessApplication* _tmp2_;
		gchar* _tmp3_;
#line 111 "../src/chess-window.vala"
		_tmp2_ = self->priv->app;
#line 111 "../src/chess-window.vala"
		_tmp3_ = chess_application_compute_current_title (_tmp2_);
#line 111 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 111 "../src/chess-window.vala"
		_tmp0_ = _tmp3_;
#line 583 "chess-window.c"
	}
#line 111 "../src/chess-window.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
#line 112 "../src/chess-window.vala"
	if (info != NULL) {
#line 589 "chess-window.c"
		gchar* _tmp5_;
#line 112 "../src/chess-window.vala"
		_tmp5_ = g_strdup (info);
#line 112 "../src/chess-window.vala"
		_g_free0 (_tmp4_);
#line 112 "../src/chess-window.vala"
		_tmp4_ = _tmp5_;
#line 597 "chess-window.c"
	} else {
		ChessApplication* _tmp6_;
		gchar* _tmp7_;
#line 112 "../src/chess-window.vala"
		_tmp6_ = self->priv->app;
#line 112 "../src/chess-window.vala"
		_tmp7_ = chess_application_compute_status_info (_tmp6_);
#line 112 "../src/chess-window.vala"
		_g_free0 (_tmp4_);
#line 112 "../src/chess-window.vala"
		_tmp4_ = _tmp7_;
#line 609 "chess-window.c"
	}
#line 112 "../src/chess-window.vala"
	_tmp8_ = self->priv->info_bar_label;
#line 112 "../src/chess-window.vala"
	gtk_label_set_label (_tmp8_, _tmp4_);
#line 114 "../src/chess-window.vala"
	_tmp9_ = self->priv->info_bar;
#line 114 "../src/chess-window.vala"
	_tmp10_ = self->priv->info_bar_label;
#line 114 "../src/chess-window.vala"
	_tmp11_ = gtk_label_get_label (_tmp10_);
#line 114 "../src/chess-window.vala"
	_tmp12_ = _tmp11_;
#line 114 "../src/chess-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, g_strcmp0 (_tmp12_, "") != 0);
#line 109 "../src/chess-window.vala"
	_g_free0 (_tmp4_);
#line 109 "../src/chess-window.vala"
	_g_free0 (_tmp0_);
#line 629 "chess-window.c"
}

void
chess_window_update_pause_resume_button (ChessWindow* self)
{
	ChessGame* game = NULL;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ChessGame* _tmp6_;
	gboolean _tmp12_ = FALSE;
	ChessGame* _tmp13_;
#line 117 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 119 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 119 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 119 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 119 "../src/chess-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 119 "../src/chess-window.vala"
	game = _tmp4_;
#line 121 "../src/chess-window.vala"
	_tmp6_ = game;
#line 121 "../src/chess-window.vala"
	if (_tmp6_ != NULL) {
#line 663 "chess-window.c"
		ChessGame* _tmp7_;
		ChessClock* _tmp8_;
		ChessClock* _tmp9_;
#line 121 "../src/chess-window.vala"
		_tmp7_ = game;
#line 121 "../src/chess-window.vala"
		_tmp8_ = chess_game_get_clock (_tmp7_);
#line 121 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 121 "../src/chess-window.vala"
		_tmp5_ = _tmp9_ == NULL;
#line 675 "chess-window.c"
	} else {
#line 121 "../src/chess-window.vala"
		_tmp5_ = FALSE;
#line 679 "chess-window.c"
	}
#line 121 "../src/chess-window.vala"
	if (_tmp5_) {
#line 683 "chess-window.c"
		GtkButton* _tmp10_;
#line 122 "../src/chess-window.vala"
		_tmp10_ = self->priv->pause_resume_button;
#line 122 "../src/chess-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 689 "chess-window.c"
	} else {
		GtkButton* _tmp11_;
#line 124 "../src/chess-window.vala"
		_tmp11_ = self->priv->pause_resume_button;
#line 124 "../src/chess-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 696 "chess-window.c"
	}
#line 126 "../src/chess-window.vala"
	_tmp13_ = game;
#line 126 "../src/chess-window.vala"
	if (_tmp13_ != NULL) {
#line 702 "chess-window.c"
		ChessGame* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 126 "../src/chess-window.vala"
		_tmp14_ = game;
#line 126 "../src/chess-window.vala"
		_tmp15_ = chess_game_get_is_paused (_tmp14_);
#line 126 "../src/chess-window.vala"
		_tmp16_ = _tmp15_;
#line 126 "../src/chess-window.vala"
		_tmp12_ = _tmp16_;
#line 714 "chess-window.c"
	} else {
#line 126 "../src/chess-window.vala"
		_tmp12_ = FALSE;
#line 718 "chess-window.c"
	}
#line 126 "../src/chess-window.vala"
	if (_tmp12_) {
#line 722 "chess-window.c"
		GtkButton* _tmp17_;
		GtkButton* _tmp18_;
#line 128 "../src/chess-window.vala"
		_tmp17_ = self->priv->pause_resume_button;
#line 128 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp17_, "media-playback-start-symbolic");
#line 129 "../src/chess-window.vala"
		_tmp18_ = self->priv->pause_resume_button;
#line 129 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp18_, _ ("Unpause the game"));
#line 733 "chess-window.c"
	} else {
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
#line 133 "../src/chess-window.vala"
		_tmp19_ = self->priv->pause_resume_button;
#line 133 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp19_, "media-playback-pause-symbolic");
#line 134 "../src/chess-window.vala"
		_tmp20_ = self->priv->pause_resume_button;
#line 134 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp20_, _ ("Pause the game"));
#line 745 "chess-window.c"
	}
#line 117 "../src/chess-window.vala"
	_g_object_unref0 (game);
#line 749 "chess-window.c"
}

void
chess_window_update_history_panel (ChessWindow* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gint move_number = 0;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint n_moves = 0;
	ChessGame* _tmp6_;
	ChessGame* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GtkComboBox* _tmp40_;
	ChessGame* _tmp41_;
	ChessGame* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
	gint i = 0;
	ChessGame* _tmp45_;
	ChessGame* _tmp46_;
	GList* _tmp47_;
	GtkComboBox* _tmp60_;
#line 138 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_game (self);
#line 140 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 140 "../src/chess-window.vala"
	if (_tmp1_ == NULL) {
#line 141 "../src/chess-window.vala"
		return;
#line 793 "chess-window.c"
	}
#line 143 "../src/chess-window.vala"
	_tmp2_ = chess_window_get_scene (self);
#line 143 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 143 "../src/chess-window.vala"
	_tmp4_ = chess_scene_get_move_number (_tmp3_);
#line 143 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/chess-window.vala"
	move_number = _tmp5_;
#line 144 "../src/chess-window.vala"
	_tmp6_ = chess_window_get_game (self);
#line 144 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 144 "../src/chess-window.vala"
	_tmp8_ = chess_game_get_n_moves (_tmp7_);
#line 144 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 144 "../src/chess-window.vala"
	n_moves = (gint) _tmp9_;
#line 145 "../src/chess-window.vala"
	if (move_number < 0) {
#line 146 "../src/chess-window.vala"
		move_number += 1 + n_moves;
#line 819 "chess-window.c"
	}
#line 148 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 148 "../src/chess-window.vala"
		_tmp11_ = move_number != 0;
#line 825 "chess-window.c"
	} else {
#line 148 "../src/chess-window.vala"
		_tmp11_ = FALSE;
#line 829 "chess-window.c"
	}
#line 148 "../src/chess-window.vala"
	if (_tmp11_) {
#line 833 "chess-window.c"
		ChessGame* _tmp12_;
		ChessGame* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
#line 148 "../src/chess-window.vala"
		_tmp12_ = chess_window_get_game (self);
#line 148 "../src/chess-window.vala"
		_tmp13_ = _tmp12_;
#line 148 "../src/chess-window.vala"
		_tmp14_ = chess_game_get_is_paused (_tmp13_);
#line 148 "../src/chess-window.vala"
		_tmp15_ = _tmp14_;
#line 148 "../src/chess-window.vala"
		_tmp10_ = !_tmp15_;
#line 848 "chess-window.c"
	} else {
#line 148 "../src/chess-window.vala"
		_tmp10_ = FALSE;
#line 852 "chess-window.c"
	}
#line 148 "../src/chess-window.vala"
	if (_tmp10_) {
#line 856 "chess-window.c"
		ChessApplication* _tmp16_;
#line 149 "../src/chess-window.vala"
		_tmp16_ = self->priv->app;
#line 149 "../src/chess-window.vala"
		chess_application_enable_action (_tmp16_, HISTORY_GO_FIRST_ACTION_NAME);
#line 862 "chess-window.c"
	} else {
		ChessApplication* _tmp17_;
#line 151 "../src/chess-window.vala"
		_tmp17_ = self->priv->app;
#line 151 "../src/chess-window.vala"
		chess_application_disable_action (_tmp17_, HISTORY_GO_FIRST_ACTION_NAME);
#line 869 "chess-window.c"
	}
#line 153 "../src/chess-window.vala"
	if (move_number > 0) {
#line 873 "chess-window.c"
		ChessGame* _tmp19_;
		ChessGame* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 153 "../src/chess-window.vala"
		_tmp19_ = chess_window_get_game (self);
#line 153 "../src/chess-window.vala"
		_tmp20_ = _tmp19_;
#line 153 "../src/chess-window.vala"
		_tmp21_ = chess_game_get_is_paused (_tmp20_);
#line 153 "../src/chess-window.vala"
		_tmp22_ = _tmp21_;
#line 153 "../src/chess-window.vala"
		_tmp18_ = !_tmp22_;
#line 888 "chess-window.c"
	} else {
#line 153 "../src/chess-window.vala"
		_tmp18_ = FALSE;
#line 892 "chess-window.c"
	}
#line 153 "../src/chess-window.vala"
	if (_tmp18_) {
#line 896 "chess-window.c"
		ChessApplication* _tmp23_;
#line 154 "../src/chess-window.vala"
		_tmp23_ = self->priv->app;
#line 154 "../src/chess-window.vala"
		chess_application_enable_action (_tmp23_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 902 "chess-window.c"
	} else {
		ChessApplication* _tmp24_;
#line 156 "../src/chess-window.vala"
		_tmp24_ = self->priv->app;
#line 156 "../src/chess-window.vala"
		chess_application_disable_action (_tmp24_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 909 "chess-window.c"
	}
#line 158 "../src/chess-window.vala"
	if (move_number < n_moves) {
#line 913 "chess-window.c"
		ChessGame* _tmp26_;
		ChessGame* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 158 "../src/chess-window.vala"
		_tmp26_ = chess_window_get_game (self);
#line 158 "../src/chess-window.vala"
		_tmp27_ = _tmp26_;
#line 158 "../src/chess-window.vala"
		_tmp28_ = chess_game_get_is_paused (_tmp27_);
#line 158 "../src/chess-window.vala"
		_tmp29_ = _tmp28_;
#line 158 "../src/chess-window.vala"
		_tmp25_ = !_tmp29_;
#line 928 "chess-window.c"
	} else {
#line 158 "../src/chess-window.vala"
		_tmp25_ = FALSE;
#line 932 "chess-window.c"
	}
#line 158 "../src/chess-window.vala"
	if (_tmp25_) {
#line 936 "chess-window.c"
		ChessApplication* _tmp30_;
#line 159 "../src/chess-window.vala"
		_tmp30_ = self->priv->app;
#line 159 "../src/chess-window.vala"
		chess_application_enable_action (_tmp30_, HISTORY_GO_NEXT_ACTION_NAME);
#line 942 "chess-window.c"
	} else {
		ChessApplication* _tmp31_;
#line 161 "../src/chess-window.vala"
		_tmp31_ = self->priv->app;
#line 161 "../src/chess-window.vala"
		chess_application_disable_action (_tmp31_, HISTORY_GO_NEXT_ACTION_NAME);
#line 949 "chess-window.c"
	}
#line 163 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 163 "../src/chess-window.vala"
		_tmp33_ = move_number != n_moves;
#line 955 "chess-window.c"
	} else {
#line 163 "../src/chess-window.vala"
		_tmp33_ = FALSE;
#line 959 "chess-window.c"
	}
#line 163 "../src/chess-window.vala"
	if (_tmp33_) {
#line 963 "chess-window.c"
		ChessGame* _tmp34_;
		ChessGame* _tmp35_;
		gboolean _tmp36_;
		gboolean _tmp37_;
#line 163 "../src/chess-window.vala"
		_tmp34_ = chess_window_get_game (self);
#line 163 "../src/chess-window.vala"
		_tmp35_ = _tmp34_;
#line 163 "../src/chess-window.vala"
		_tmp36_ = chess_game_get_is_paused (_tmp35_);
#line 163 "../src/chess-window.vala"
		_tmp37_ = _tmp36_;
#line 163 "../src/chess-window.vala"
		_tmp32_ = !_tmp37_;
#line 978 "chess-window.c"
	} else {
#line 163 "../src/chess-window.vala"
		_tmp32_ = FALSE;
#line 982 "chess-window.c"
	}
#line 163 "../src/chess-window.vala"
	if (_tmp32_) {
#line 986 "chess-window.c"
		ChessApplication* _tmp38_;
#line 164 "../src/chess-window.vala"
		_tmp38_ = self->priv->app;
#line 164 "../src/chess-window.vala"
		chess_application_enable_action (_tmp38_, HISTORY_GO_LAST_ACTION_NAME);
#line 992 "chess-window.c"
	} else {
		ChessApplication* _tmp39_;
#line 166 "../src/chess-window.vala"
		_tmp39_ = self->priv->app;
#line 166 "../src/chess-window.vala"
		chess_application_disable_action (_tmp39_, HISTORY_GO_LAST_ACTION_NAME);
#line 999 "chess-window.c"
	}
#line 168 "../src/chess-window.vala"
	_tmp40_ = self->priv->history_combo;
#line 168 "../src/chess-window.vala"
	_tmp41_ = chess_window_get_game (self);
#line 168 "../src/chess-window.vala"
	_tmp42_ = _tmp41_;
#line 168 "../src/chess-window.vala"
	_tmp43_ = chess_game_get_is_paused (_tmp42_);
#line 168 "../src/chess-window.vala"
	_tmp44_ = _tmp43_;
#line 168 "../src/chess-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, !_tmp44_);
#line 171 "../src/chess-window.vala"
	i = n_moves;
#line 172 "../src/chess-window.vala"
	_tmp45_ = chess_window_get_game (self);
#line 172 "../src/chess-window.vala"
	_tmp46_ = _tmp45_;
#line 172 "../src/chess-window.vala"
	_tmp47_ = _tmp46_->move_stack;
#line 1021 "chess-window.c"
	{
		GList* state_collection = NULL;
		GList* state_it = NULL;
#line 172 "../src/chess-window.vala"
		state_collection = _tmp47_;
#line 172 "../src/chess-window.vala"
		for (state_it = state_collection; state_it != NULL; state_it = state_it->next) {
#line 1029 "chess-window.c"
			ChessState* _tmp48_;
			ChessState* state = NULL;
#line 172 "../src/chess-window.vala"
			_tmp48_ = _g_object_ref0 ((ChessState*) state_it->data);
#line 172 "../src/chess-window.vala"
			state = _tmp48_;
#line 1036 "chess-window.c"
			{
				ChessState* _tmp49_;
				ChessMove* _tmp50_;
				gint _tmp59_;
#line 174 "../src/chess-window.vala"
				_tmp49_ = state;
#line 174 "../src/chess-window.vala"
				_tmp50_ = _tmp49_->last_move;
#line 174 "../src/chess-window.vala"
				if (_tmp50_ != NULL) {
#line 1047 "chess-window.c"
					GtkTreeIter iter = {0};
					GtkComboBox* _tmp51_;
					GtkTreeModel* _tmp52_;
					GtkTreeModel* _tmp53_;
					GtkTreeIter _tmp54_ = {0};
					gboolean _tmp55_;
#line 177 "../src/chess-window.vala"
					_tmp51_ = self->priv->history_combo;
#line 177 "../src/chess-window.vala"
					_tmp52_ = gtk_combo_box_get_model (_tmp51_);
#line 177 "../src/chess-window.vala"
					_tmp53_ = _tmp52_;
#line 177 "../src/chess-window.vala"
					_tmp55_ = gtk_tree_model_iter_nth_child (_tmp53_, &_tmp54_, NULL, i);
#line 177 "../src/chess-window.vala"
					iter = _tmp54_;
#line 177 "../src/chess-window.vala"
					if (_tmp55_) {
#line 1066 "chess-window.c"
						GtkTreeIter _tmp56_;
						ChessState* _tmp57_;
						ChessMove* _tmp58_;
#line 178 "../src/chess-window.vala"
						_tmp56_ = iter;
#line 178 "../src/chess-window.vala"
						_tmp57_ = state;
#line 178 "../src/chess-window.vala"
						_tmp58_ = _tmp57_->last_move;
#line 178 "../src/chess-window.vala"
						chess_window_set_move_text (self, &_tmp56_, _tmp58_);
#line 1078 "chess-window.c"
					}
				}
#line 180 "../src/chess-window.vala"
				_tmp59_ = i;
#line 180 "../src/chess-window.vala"
				i = _tmp59_ - 1;
#line 172 "../src/chess-window.vala"
				_g_object_unref0 (state);
#line 1087 "chess-window.c"
			}
		}
	}
#line 183 "../src/chess-window.vala"
	_tmp60_ = self->priv->history_combo;
#line 183 "../src/chess-window.vala"
	gtk_combo_box_set_active (_tmp60_, move_number);
#line 1095 "chess-window.c"
}

void
chess_window_set_clock_visible (ChessWindow* self,
                                gboolean visible)
{
	GtkBox* _tmp0_;
#line 186 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/chess-window.vala"
	_tmp0_ = self->priv->clock_box;
#line 188 "../src/chess-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, visible);
#line 1109 "chess-window.c"
}

static gint
chess_window_compute_time_label_width_request (ChessWindow* self,
                                               cairo_t* c)
{
	cairo_text_extents_t extents = {0};
	gdouble max = 0.0;
	cairo_text_extents_t _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	cairo_text_extents_t _tmp6_;
	cairo_text_extents_t _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	cairo_text_extents_t _tmp10_;
	cairo_text_extents_t _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	cairo_text_extents_t _tmp14_;
	cairo_text_extents_t _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	cairo_text_extents_t _tmp18_;
	cairo_text_extents_t _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	cairo_text_extents_t _tmp22_;
	cairo_text_extents_t _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	cairo_text_extents_t _tmp26_;
	cairo_text_extents_t _tmp28_ = {0};
	gdouble _tmp29_ = 0.0;
	cairo_text_extents_t _tmp30_;
	cairo_text_extents_t _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	cairo_text_extents_t _tmp34_;
	cairo_text_extents_t _tmp36_ = {0};
	gdouble _tmp37_ = 0.0;
	cairo_text_extents_t _tmp38_;
	gint result = 0;
#line 195 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "../src/chess-window.vala"
	g_return_val_if_fail (c != NULL, 0);
#line 199 "../src/chess-window.vala"
	max = (gdouble) 0;
#line 201 "../src/chess-window.vala"
	cairo_text_extents (c, "000∶00", &_tmp0_);
#line 201 "../src/chess-window.vala"
	extents = _tmp0_;
#line 202 "../src/chess-window.vala"
	_tmp2_ = extents;
#line 202 "../src/chess-window.vala"
	if (max > _tmp2_.width) {
#line 202 "../src/chess-window.vala"
		_tmp1_ = max;
#line 1165 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp3_;
#line 202 "../src/chess-window.vala"
		_tmp3_ = extents;
#line 202 "../src/chess-window.vala"
		_tmp1_ = _tmp3_.width;
#line 1172 "chess-window.c"
	}
#line 202 "../src/chess-window.vala"
	max = _tmp1_;
#line 203 "../src/chess-window.vala"
	cairo_text_extents (c, "111∶11", &_tmp4_);
#line 203 "../src/chess-window.vala"
	extents = _tmp4_;
#line 204 "../src/chess-window.vala"
	_tmp6_ = extents;
#line 204 "../src/chess-window.vala"
	if (max > _tmp6_.width) {
#line 204 "../src/chess-window.vala"
		_tmp5_ = max;
#line 1186 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp7_;
#line 204 "../src/chess-window.vala"
		_tmp7_ = extents;
#line 204 "../src/chess-window.vala"
		_tmp5_ = _tmp7_.width;
#line 1193 "chess-window.c"
	}
#line 204 "../src/chess-window.vala"
	max = _tmp5_;
#line 205 "../src/chess-window.vala"
	cairo_text_extents (c, "222∶22", &_tmp8_);
#line 205 "../src/chess-window.vala"
	extents = _tmp8_;
#line 206 "../src/chess-window.vala"
	_tmp10_ = extents;
#line 206 "../src/chess-window.vala"
	if (max > _tmp10_.width) {
#line 206 "../src/chess-window.vala"
		_tmp9_ = max;
#line 1207 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp11_;
#line 206 "../src/chess-window.vala"
		_tmp11_ = extents;
#line 206 "../src/chess-window.vala"
		_tmp9_ = _tmp11_.width;
#line 1214 "chess-window.c"
	}
#line 206 "../src/chess-window.vala"
	max = _tmp9_;
#line 207 "../src/chess-window.vala"
	cairo_text_extents (c, "333∶33", &_tmp12_);
#line 207 "../src/chess-window.vala"
	extents = _tmp12_;
#line 208 "../src/chess-window.vala"
	_tmp14_ = extents;
#line 208 "../src/chess-window.vala"
	if (max > _tmp14_.width) {
#line 208 "../src/chess-window.vala"
		_tmp13_ = max;
#line 1228 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp15_;
#line 208 "../src/chess-window.vala"
		_tmp15_ = extents;
#line 208 "../src/chess-window.vala"
		_tmp13_ = _tmp15_.width;
#line 1235 "chess-window.c"
	}
#line 208 "../src/chess-window.vala"
	max = _tmp13_;
#line 209 "../src/chess-window.vala"
	cairo_text_extents (c, "444∶44", &_tmp16_);
#line 209 "../src/chess-window.vala"
	extents = _tmp16_;
#line 210 "../src/chess-window.vala"
	_tmp18_ = extents;
#line 210 "../src/chess-window.vala"
	if (max > _tmp18_.width) {
#line 210 "../src/chess-window.vala"
		_tmp17_ = max;
#line 1249 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp19_;
#line 210 "../src/chess-window.vala"
		_tmp19_ = extents;
#line 210 "../src/chess-window.vala"
		_tmp17_ = _tmp19_.width;
#line 1256 "chess-window.c"
	}
#line 210 "../src/chess-window.vala"
	max = _tmp17_;
#line 211 "../src/chess-window.vala"
	cairo_text_extents (c, "555∶55", &_tmp20_);
#line 211 "../src/chess-window.vala"
	extents = _tmp20_;
#line 212 "../src/chess-window.vala"
	_tmp22_ = extents;
#line 212 "../src/chess-window.vala"
	if (max > _tmp22_.width) {
#line 212 "../src/chess-window.vala"
		_tmp21_ = max;
#line 1270 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp23_;
#line 212 "../src/chess-window.vala"
		_tmp23_ = extents;
#line 212 "../src/chess-window.vala"
		_tmp21_ = _tmp23_.width;
#line 1277 "chess-window.c"
	}
#line 212 "../src/chess-window.vala"
	max = _tmp21_;
#line 213 "../src/chess-window.vala"
	cairo_text_extents (c, "666∶66", &_tmp24_);
#line 213 "../src/chess-window.vala"
	extents = _tmp24_;
#line 214 "../src/chess-window.vala"
	_tmp26_ = extents;
#line 214 "../src/chess-window.vala"
	if (max > _tmp26_.width) {
#line 214 "../src/chess-window.vala"
		_tmp25_ = max;
#line 1291 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp27_;
#line 214 "../src/chess-window.vala"
		_tmp27_ = extents;
#line 214 "../src/chess-window.vala"
		_tmp25_ = _tmp27_.width;
#line 1298 "chess-window.c"
	}
#line 214 "../src/chess-window.vala"
	max = _tmp25_;
#line 215 "../src/chess-window.vala"
	cairo_text_extents (c, "777∶77", &_tmp28_);
#line 215 "../src/chess-window.vala"
	extents = _tmp28_;
#line 216 "../src/chess-window.vala"
	_tmp30_ = extents;
#line 216 "../src/chess-window.vala"
	if (max > _tmp30_.width) {
#line 216 "../src/chess-window.vala"
		_tmp29_ = max;
#line 1312 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp31_;
#line 216 "../src/chess-window.vala"
		_tmp31_ = extents;
#line 216 "../src/chess-window.vala"
		_tmp29_ = _tmp31_.width;
#line 1319 "chess-window.c"
	}
#line 216 "../src/chess-window.vala"
	max = _tmp29_;
#line 217 "../src/chess-window.vala"
	cairo_text_extents (c, "888∶88", &_tmp32_);
#line 217 "../src/chess-window.vala"
	extents = _tmp32_;
#line 218 "../src/chess-window.vala"
	_tmp34_ = extents;
#line 218 "../src/chess-window.vala"
	if (max > _tmp34_.width) {
#line 218 "../src/chess-window.vala"
		_tmp33_ = max;
#line 1333 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp35_;
#line 218 "../src/chess-window.vala"
		_tmp35_ = extents;
#line 218 "../src/chess-window.vala"
		_tmp33_ = _tmp35_.width;
#line 1340 "chess-window.c"
	}
#line 218 "../src/chess-window.vala"
	max = _tmp33_;
#line 219 "../src/chess-window.vala"
	cairo_text_extents (c, "999∶99", &_tmp36_);
#line 219 "../src/chess-window.vala"
	extents = _tmp36_;
#line 220 "../src/chess-window.vala"
	_tmp38_ = extents;
#line 220 "../src/chess-window.vala"
	if (max > _tmp38_.width) {
#line 220 "../src/chess-window.vala"
		_tmp37_ = max;
#line 1354 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp39_;
#line 220 "../src/chess-window.vala"
		_tmp39_ = extents;
#line 220 "../src/chess-window.vala"
		_tmp37_ = _tmp39_.width;
#line 1361 "chess-window.c"
	}
#line 220 "../src/chess-window.vala"
	max = _tmp37_;
#line 223 "../src/chess-window.vala"
	result = ((gint) ceil (max)) + 6;
#line 223 "../src/chess-window.vala"
	_vala_warn_if_fail (result > 0, "result > 0");
#line 223 "../src/chess-window.vala"
	return result;
#line 1371 "chess-window.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 226 "../src/chess-window.vala"
	return self ? cairo_reference (self) : NULL;
#line 1379 "chess-window.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 226 "../src/chess-window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 226 "../src/chess-window.vala"
	return _data2_;
#line 1389 "chess-window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 226 "../src/chess-window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1399 "chess-window.c"
		ChessWindow* self;
#line 226 "../src/chess-window.vala"
		self = _data2_->self;
#line 226 "../src/chess-window.vala"
		_g_object_unref0 (_data2_->widget);
#line 226 "../src/chess-window.vala"
		_cairo_destroy0 (_data2_->c);
#line 226 "../src/chess-window.vala"
		_g_object_unref0 (self);
#line 226 "../src/chess-window.vala"
		g_slice_free (Block2Data, _data2_);
#line 1411 "chess-window.c"
	}
}

static gboolean
___lambda26_ (Block2Data* _data2_)
{
	ChessWindow* self;
	gboolean result = FALSE;
#line 236 "../src/chess-window.vala"
	self = _data2_->self;
#line 237 "../src/chess-window.vala"
	gtk_widget_set_size_request (_data2_->widget, chess_window_compute_time_label_width_request (self, _data2_->c), -1);
#line 238 "../src/chess-window.vala"
	gtk_widget_queue_draw (_data2_->widget);
#line 239 "../src/chess-window.vala"
	result = G_SOURCE_REMOVE;
#line 239 "../src/chess-window.vala"
	return result;
#line 1430 "chess-window.c"
}

static gboolean
____lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda26_ (self);
#line 236 "../src/chess-window.vala"
	return result;
#line 1440 "chess-window.c"
}

static void
chess_window_draw_time (ChessWindow* self,
                        GtkWidget* widget,
                        cairo_t* c,
                        gint width,
                        gint height,
                        const gchar* text,
                        gdouble* fg,
                        gint fg_length1,
                        gdouble* bg,
                        gint bg_length1)
{
	Block2Data* _data2_;
	GtkWidget* _tmp0_;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble alpha = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp10_ = {0};
	cairo_text_extents_t _tmp11_;
	cairo_text_extents_t _tmp12_;
	cairo_text_extents_t _tmp13_;
	cairo_text_extents_t _tmp14_;
#line 226 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/chess-window.vala"
	g_return_if_fail (widget != NULL);
#line 226 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 226 "../src/chess-window.vala"
	g_return_if_fail (text != NULL);
#line 226 "../src/chess-window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 226 "../src/chess-window.vala"
	_data2_->_ref_count_ = 1;
#line 226 "../src/chess-window.vala"
	_data2_->self = g_object_ref (self);
#line 226 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (widget);
#line 226 "../src/chess-window.vala"
	_g_object_unref0 (_data2_->widget);
#line 226 "../src/chess-window.vala"
	_data2_->widget = _tmp0_;
#line 226 "../src/chess-window.vala"
	_tmp1_ = _cairo_reference0 (c);
#line 226 "../src/chess-window.vala"
	_cairo_destroy0 (_data2_->c);
#line 226 "../src/chess-window.vala"
	_data2_->c = _tmp1_;
#line 234 "../src/chess-window.vala"
	g_object_get (_data2_->widget, "width-request", &_tmp2_, NULL);
#line 234 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 234 "../src/chess-window.vala"
	if (_tmp3_ == -1) {
#line 236 "../src/chess-window.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda26__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 241 "../src/chess-window.vala"
		block2_data_unref (_data2_);
#line 241 "../src/chess-window.vala"
		_data2_ = NULL;
#line 241 "../src/chess-window.vala"
		return;
#line 1513 "chess-window.c"
	}
#line 244 "../src/chess-window.vala"
	alpha = 1.0;
#line 245 "../src/chess-window.vala"
	if ((gtk_widget_get_state_flags (_data2_->widget) & GTK_STATE_FLAG_INSENSITIVE) != 0) {
#line 246 "../src/chess-window.vala"
		alpha = 0.5;
#line 1521 "chess-window.c"
	}
#line 247 "../src/chess-window.vala"
	_tmp4_ = bg[0];
#line 247 "../src/chess-window.vala"
	_tmp5_ = bg[1];
#line 247 "../src/chess-window.vala"
	_tmp6_ = bg[2];
#line 247 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp4_, _tmp5_, _tmp6_, alpha);
#line 248 "../src/chess-window.vala"
	cairo_paint (_data2_->c);
#line 250 "../src/chess-window.vala"
	_tmp7_ = fg[0];
#line 250 "../src/chess-window.vala"
	_tmp8_ = fg[1];
#line 250 "../src/chess-window.vala"
	_tmp9_ = fg[2];
#line 250 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp7_, _tmp8_, _tmp9_, alpha);
#line 251 "../src/chess-window.vala"
	cairo_select_font_face (_data2_->c, "fixed", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 252 "../src/chess-window.vala"
	cairo_set_font_size (_data2_->c, 0.6 * gtk_widget_get_allocated_height (_data2_->widget));
#line 254 "../src/chess-window.vala"
	cairo_text_extents (_data2_->c, text, &_tmp10_);
#line 254 "../src/chess-window.vala"
	extents = _tmp10_;
#line 255 "../src/chess-window.vala"
	_tmp11_ = extents;
#line 255 "../src/chess-window.vala"
	_tmp12_ = extents;
#line 255 "../src/chess-window.vala"
	_tmp13_ = extents;
#line 255 "../src/chess-window.vala"
	_tmp14_ = extents;
#line 255 "../src/chess-window.vala"
	cairo_move_to (_data2_->c, ((gtk_widget_get_allocated_width (_data2_->widget) - _tmp11_.width) / 2) - _tmp12_.x_bearing, ((gtk_widget_get_allocated_height (_data2_->widget) - _tmp13_.height) / 2) - _tmp14_.y_bearing);
#line 257 "../src/chess-window.vala"
	cairo_show_text (_data2_->c, text);
#line 226 "../src/chess-window.vala"
	block2_data_unref (_data2_);
#line 226 "../src/chess-window.vala"
	_data2_ = NULL;
#line 1565 "chess-window.c"
}

static gchar*
chess_window_make_clock_text (ChessWindow* self,
                              ChessClock* clock,
                              Color color)
{
	gint time = 0;
	gchar* result = NULL;
#line 260 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 260 "../src/chess-window.vala"
	_vala_return_val_if_fail (clock != NULL, "clock != null", NULL);
#line 264 "../src/chess-window.vala"
	if (color == COLOR_WHITE) {
#line 1581 "chess-window.c"
		gint _tmp0_;
		gint _tmp1_;
#line 265 "../src/chess-window.vala"
		_tmp0_ = chess_clock_get_white_remaining_seconds (clock);
#line 265 "../src/chess-window.vala"
		_tmp1_ = _tmp0_;
#line 265 "../src/chess-window.vala"
		time = _tmp1_;
#line 1590 "chess-window.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 267 "../src/chess-window.vala"
		_tmp2_ = chess_clock_get_black_remaining_seconds (clock);
#line 267 "../src/chess-window.vala"
		_tmp3_ = _tmp2_;
#line 267 "../src/chess-window.vala"
		time = _tmp3_;
#line 1600 "chess-window.c"
	}
#line 269 "../src/chess-window.vala"
	if (time >= 60) {
#line 1604 "chess-window.c"
		gchar* _tmp4_;
#line 270 "../src/chess-window.vala"
		_tmp4_ = g_strdup_printf ("%d∶\xE2\x80\x8E%02d", time / 60, time % 60);
#line 270 "../src/chess-window.vala"
		result = _tmp4_;
#line 270 "../src/chess-window.vala"
		return result;
#line 1612 "chess-window.c"
	} else {
		gchar* _tmp5_;
#line 272 "../src/chess-window.vala"
		_tmp5_ = g_strdup_printf ("∶\xE2\x80\x8E%02d", time);
#line 272 "../src/chess-window.vala"
		result = _tmp5_;
#line 272 "../src/chess-window.vala"
		return result;
#line 1621 "chess-window.c"
	}
}

static void
chess_window_draw_white_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 275 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 275 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 277 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 277 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 277 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 277 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 277 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 277 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 277 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_WHITE);
#line 277 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 277 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 277 "../src/chess-window.vala"
	_tmp8_[0] = 0.0;
#line 277 "../src/chess-window.vala"
	_tmp8_[1] = 0.0;
#line 277 "../src/chess-window.vala"
	_tmp8_[2] = 0.0;
#line 277 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 277 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 277 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 277 "../src/chess-window.vala"
	_tmp10_[0] = 1.0;
#line 277 "../src/chess-window.vala"
	_tmp10_[1] = 1.0;
#line 277 "../src/chess-window.vala"
	_tmp10_[2] = 1.0;
#line 277 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 277 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 277 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 277 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 277 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 277 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1700 "chess-window.c"
}

static void
chess_window_draw_black_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 280 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 280 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 280 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 282 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 282 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 282 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 282 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 282 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 282 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 282 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_BLACK);
#line 282 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 282 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 282 "../src/chess-window.vala"
	_tmp8_[0] = 1.0;
#line 282 "../src/chess-window.vala"
	_tmp8_[1] = 1.0;
#line 282 "../src/chess-window.vala"
	_tmp8_[2] = 1.0;
#line 282 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 282 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 282 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 282 "../src/chess-window.vala"
	_tmp10_[0] = 0.0;
#line 282 "../src/chess-window.vala"
	_tmp10_[1] = 0.0;
#line 282 "../src/chess-window.vala"
	_tmp10_[2] = 0.0;
#line 282 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 282 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 282 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 282 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 282 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 282 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1778 "chess-window.c"
}

static void
chess_window_history_combo_changed_cb (ChessWindow* self,
                                       GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gint move_number = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	ChessGame* _tmp7_;
	ChessGame* _tmp8_;
	ChessScene* _tmp13_;
	ChessScene* _tmp14_;
#line 286 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/chess-window.vala"
	g_return_if_fail (combo != NULL);
#line 289 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 289 "../src/chess-window.vala"
	iter = _tmp0_;
#line 289 "../src/chess-window.vala"
	if (!_tmp1_) {
#line 290 "../src/chess-window.vala"
		return;
#line 1810 "chess-window.c"
	}
#line 292 "../src/chess-window.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 292 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 292 "../src/chess-window.vala"
	_tmp4_ = iter;
#line 292 "../src/chess-window.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 292 "../src/chess-window.vala"
	move_number = _tmp5_;
#line 293 "../src/chess-window.vala"
	_tmp7_ = chess_window_get_game (self);
#line 293 "../src/chess-window.vala"
	_tmp8_ = _tmp7_;
#line 293 "../src/chess-window.vala"
	if (_tmp8_ == NULL) {
#line 293 "../src/chess-window.vala"
		_tmp6_ = TRUE;
#line 1830 "chess-window.c"
	} else {
		ChessGame* _tmp9_;
		ChessGame* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 293 "../src/chess-window.vala"
		_tmp9_ = chess_window_get_game (self);
#line 293 "../src/chess-window.vala"
		_tmp10_ = _tmp9_;
#line 293 "../src/chess-window.vala"
		_tmp11_ = chess_game_get_n_moves (_tmp10_);
#line 293 "../src/chess-window.vala"
		_tmp12_ = _tmp11_;
#line 293 "../src/chess-window.vala"
		_tmp6_ = ((guint) move_number) == _tmp12_;
#line 1846 "chess-window.c"
	}
#line 293 "../src/chess-window.vala"
	if (_tmp6_) {
#line 294 "../src/chess-window.vala"
		move_number = -1;
#line 1852 "chess-window.c"
	}
#line 295 "../src/chess-window.vala"
	_tmp13_ = chess_window_get_scene (self);
#line 295 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 295 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp14_, move_number);
#line 1860 "chess-window.c"
}

static void
_chess_window_history_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                              gpointer self)
{
#line 14 "../src/chess-window.vala"
	chess_window_history_combo_changed_cb ((ChessWindow*) self, _sender);
#line 1869 "chess-window.c"
}

void
chess_window_set_move_text (ChessWindow* self,
                            GtkTreeIter* iter,
                            ChessMove* move)
{
#line 301 "../src/chess-window.vala"
	static const gchar* human_descriptions[72] = {N_ ("White pawn moves from %1$s to %2$s"), N_ ("White pawn at %1$s takes the black pawn at %2$s"), N_ ("White pawn at %1$s takes the black rook at %2$s"), N_ ("White pawn at %1$s takes the black knight at %2$s"), N_ ("White pawn at %1$s takes the black bishop at %2$s"), N_ ("White pawn at %1$s takes the black queen at %2$s"), N_ ("White rook moves from %1$s to %2$s"), N_ ("White rook at %1$s takes the black pawn at %2$s"), N_ ("White rook at %1$s takes the black rook at %2$s"), N_ ("White rook at %1$s takes the black knight at %2$s"), N_ ("White rook at %1$s takes the black bishop at %2$s"), N_ ("White rook at %1$s takes the black queen at %2$s"), N_ ("White knight moves from %1$s to %2$s"), N_ ("White knight at %1$s takes the black pawn at %2$s"), N_ ("White knight at %1$s takes the black rook at %2$s"), N_ ("White knight at %1$s takes the black knight at %2$s"), N_ ("White knight at %1$s takes the black bishop at %2$s"), N_ ("White knight at %1$s takes the black queen at %2$s"), N_ ("White bishop moves from %1$s to %2$s"), N_ ("White bishop at %1$s takes the black pawn at %2$s"), N_ ("White bishop at %1$s takes the black rook at %2$s"), N_ ("White bishop at %1$s takes the black knight at %2$s"), N_ ("White bishop at %1$s takes the black bishop at %2$s"), N_ ("White bishop at %1$s takes the black queen at %2$s"), N_ ("White queen moves from %1$s to %2$s"), N_ ("White queen at %1$s takes the black pawn at %2$s"), N_ ("White queen at %1$s takes the black rook at %2$s"), N_ ("White queen at %1$s takes the black knight at %2$s"), N_ ("White queen at %1$s takes the black bishop at %2$s"), N_ ("White queen at %1$s takes the black queen at %2$s"), N_ ("White king moves from %1$s to %2$s"), N_ ("White king at %1$s takes the black pawn at %2$s"), N_ ("White king at %1$s takes the black rook at %2$s"), N_ ("White king at %1$s takes the black knight at %2$s"), N_ ("White king at %1$s takes the black bishop at %2$s"), N_ ("White king at %1$s takes the black queen at %2$s"), N_ ("Black pawn moves from %1$s to %2$s"), N_ ("Black pawn at %1$s takes the white pawn at %2$s"), N_ ("Black pawn at %1$s takes the white rook at %2$s"), N_ ("Black pawn at %1$s takes the white knight at %2$s"), N_ ("Black pawn at %1$s takes the white bishop at %2$s"), N_ ("Black pawn at %1$s takes the white queen at %2$s"), N_ ("Black rook moves from %1$s to %2$s"), N_ ("Black rook at %1$s takes the white pawn at %2$s"), N_ ("Black rook at %1$s takes the white rook at %2$s"), N_ ("Black rook at %1$s takes the white knight at %2$s"), N_ ("Black rook at %1$s takes the white bishop at %2$s"), N_ ("Black rook at %1$s takes the white queen at %2$s"), N_ ("Black knight moves from %1$s to %2$s"), N_ ("Black knight at %1$s takes the white pawn at %2$s"), N_ ("Black knight at %1$s takes the white rook at %2$s"), N_ ("Black knight at %1$s takes the white knight at %2$s"), N_ ("Black knight at %1$s takes the white bishop at %2$s"), N_ ("Black knight at %1$s takes the white queen at %2$s"), N_ ("Black bishop moves from %1$s to %2$s"), N_ ("Black bishop at %1$s takes the white pawn at %2$s"), N_ ("Black bishop at %1$s takes the white rook at %2$s"), N_ ("Black bishop at %1$s takes the white knight at %2$s"), N_ ("Black bishop at %1$s takes the white bishop at %2$s"), N_ ("Black bishop at %1$s takes the white queen at %2$s"), N_ ("Black queen moves from %1$s to %2$s"), N_ ("Black queen at %1$s takes the white pawn at %2$s"), N_ ("Black queen at %1$s takes the white rook at %2$s"), N_ ("Black queen at %1$s takes the white knight at %2$s"), N_ ("Black queen at %1$s takes the white bishop at %2$s"), N_ ("Black queen at %1$s takes the white queen at %2$s"), N_ ("Black king moves from %1$s to %2$s"), N_ ("Black king at %1$s takes the white pawn at %2$s"), N_ ("Black king at %1$s takes the white rook at %2$s"), N_ ("Black king at %1$s takes the white knight at %2$s"), N_ ("Black king at %1$s takes the white bishop at %2$s"), N_ ("Black king at %1$s takes the white queen at %2$s")};
#line 1879 "chess-window.c"
	gchar* move_text = NULL;
	gchar* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 447 "../src/chess-window.vala"
	static GQuark _tmp6_label0 = 0;
#line 447 "../src/chess-window.vala"
	static GQuark _tmp6_label1 = 0;
#line 447 "../src/chess-window.vala"
	static GQuark _tmp6_label2 = 0;
#line 1894 "chess-window.c"
	GtkListStore* model = NULL;
	GtkComboBox* _tmp35_;
	GtkTreeModel* _tmp36_;
	GtkTreeModel* _tmp37_;
	GtkListStore* _tmp38_;
	gchar _tmp39_ = '\0';
	gchar* label = NULL;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GtkListStore* _tmp42_;
	GtkTreeIter _tmp43_;
#line 298 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/chess-window.vala"
	g_return_if_fail (iter != NULL);
#line 298 "../src/chess-window.vala"
	g_return_if_fail (move != NULL);
#line 446 "../src/chess-window.vala"
	_tmp0_ = g_strdup ("");
#line 446 "../src/chess-window.vala"
	move_text = _tmp0_;
#line 447 "../src/chess-window.vala"
	_tmp1_ = chess_window_get_scene (self);
#line 447 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 447 "../src/chess-window.vala"
	_tmp3_ = chess_scene_get_move_format (_tmp2_);
#line 447 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 447 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 447 "../src/chess-window.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 447 "../src/chess-window.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("human")))) {
#line 447 "../src/chess-window.vala"
		switch (0) {
#line 1932 "chess-window.c"
			default:
			{
				ChessPiece* _tmp8_;
#line 450 "../src/chess-window.vala"
				_tmp8_ = move->castling_rook;
#line 450 "../src/chess-window.vala"
				if (_tmp8_ != NULL) {
#line 1940 "chess-window.c"
					gboolean _tmp9_ = FALSE;
#line 452 "../src/chess-window.vala"
					if (move->f0 < move->f1) {
#line 452 "../src/chess-window.vala"
						_tmp9_ = move->r0 == 0;
#line 1946 "chess-window.c"
					} else {
#line 452 "../src/chess-window.vala"
						_tmp9_ = FALSE;
#line 1950 "chess-window.c"
					}
#line 452 "../src/chess-window.vala"
					if (_tmp9_) {
#line 1954 "chess-window.c"
						gchar* _tmp10_;
#line 453 "../src/chess-window.vala"
						_tmp10_ = g_strdup (_ ("White castles kingside"));
#line 453 "../src/chess-window.vala"
						_g_free0 (move_text);
#line 453 "../src/chess-window.vala"
						move_text = _tmp10_;
#line 1962 "chess-window.c"
					} else {
						gboolean _tmp11_ = FALSE;
#line 454 "../src/chess-window.vala"
						if (move->f1 < move->f0) {
#line 454 "../src/chess-window.vala"
							_tmp11_ = move->r0 == 0;
#line 1969 "chess-window.c"
						} else {
#line 454 "../src/chess-window.vala"
							_tmp11_ = FALSE;
#line 1973 "chess-window.c"
						}
#line 454 "../src/chess-window.vala"
						if (_tmp11_) {
#line 1977 "chess-window.c"
							gchar* _tmp12_;
#line 455 "../src/chess-window.vala"
							_tmp12_ = g_strdup (_ ("White castles queenside"));
#line 455 "../src/chess-window.vala"
							_g_free0 (move_text);
#line 455 "../src/chess-window.vala"
							move_text = _tmp12_;
#line 1985 "chess-window.c"
						} else {
							gboolean _tmp13_ = FALSE;
#line 456 "../src/chess-window.vala"
							if (move->f0 < move->f1) {
#line 456 "../src/chess-window.vala"
								_tmp13_ = move->r0 == 7;
#line 1992 "chess-window.c"
							} else {
#line 456 "../src/chess-window.vala"
								_tmp13_ = FALSE;
#line 1996 "chess-window.c"
							}
#line 456 "../src/chess-window.vala"
							if (_tmp13_) {
#line 2000 "chess-window.c"
								gchar* _tmp14_;
#line 457 "../src/chess-window.vala"
								_tmp14_ = g_strdup (_ ("Black castles kingside"));
#line 457 "../src/chess-window.vala"
								_g_free0 (move_text);
#line 457 "../src/chess-window.vala"
								move_text = _tmp14_;
#line 2008 "chess-window.c"
							} else {
								gboolean _tmp15_ = FALSE;
#line 458 "../src/chess-window.vala"
								if (move->f1 < move->f0) {
#line 458 "../src/chess-window.vala"
									_tmp15_ = move->r0 == 7;
#line 2015 "chess-window.c"
								} else {
#line 458 "../src/chess-window.vala"
									_tmp15_ = FALSE;
#line 2019 "chess-window.c"
								}
#line 458 "../src/chess-window.vala"
								if (_tmp15_) {
#line 2023 "chess-window.c"
									gchar* _tmp16_;
#line 459 "../src/chess-window.vala"
									_tmp16_ = g_strdup (_ ("Black castles queenside"));
#line 459 "../src/chess-window.vala"
									_g_free0 (move_text);
#line 459 "../src/chess-window.vala"
									move_text = _tmp16_;
#line 2031 "chess-window.c"
								} else {
#line 461 "../src/chess-window.vala"
									g_assert_not_reached ();
#line 2035 "chess-window.c"
								}
							}
						}
					}
				} else {
					gint index = 0;
					ChessPiece* _tmp17_;
					ChessPiece* _tmp19_;
					ChessPiece* _tmp20_;
					ChessPlayer* _tmp21_;
					gchar* start = NULL;
					gchar* _tmp22_;
					gchar* end = NULL;
					gchar* _tmp23_;
					gchar* template = NULL;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 466 "../src/chess-window.vala"
					_tmp17_ = move->victim;
#line 466 "../src/chess-window.vala"
					if (_tmp17_ == NULL) {
#line 467 "../src/chess-window.vala"
						index = 0;
#line 2063 "chess-window.c"
					} else {
						ChessPiece* _tmp18_;
#line 469 "../src/chess-window.vala"
						_tmp18_ = move->victim;
#line 469 "../src/chess-window.vala"
						index = (gint) (_tmp18_->type + 1);
#line 2070 "chess-window.c"
					}
#line 470 "../src/chess-window.vala"
					_tmp19_ = move->piece;
#line 470 "../src/chess-window.vala"
					index += (gint) (_tmp19_->type * 6);
#line 471 "../src/chess-window.vala"
					_tmp20_ = move->piece;
#line 471 "../src/chess-window.vala"
					_tmp21_ = _tmp20_->player;
#line 471 "../src/chess-window.vala"
					if (_tmp21_->color == COLOR_BLACK) {
#line 472 "../src/chess-window.vala"
						index += 36;
#line 2084 "chess-window.c"
					}
#line 474 "../src/chess-window.vala"
					_tmp22_ = g_strdup_printf ("%c%d", 'a' + move->f0, move->r0 + 1);
#line 474 "../src/chess-window.vala"
					start = _tmp22_;
#line 475 "../src/chess-window.vala"
					_tmp23_ = g_strdup_printf ("%c%d", 'a' + move->f1, move->r1 + 1);
#line 475 "../src/chess-window.vala"
					end = _tmp23_;
#line 476 "../src/chess-window.vala"
					_tmp24_ = human_descriptions[index];
#line 476 "../src/chess-window.vala"
					_tmp25_ = g_strdup (_ (_tmp24_));
#line 476 "../src/chess-window.vala"
					template = _tmp25_;
#line 477 "../src/chess-window.vala"
					if (move->en_passant) {
#line 479 "../src/chess-window.vala"
						if (move->r0 < move->r1) {
#line 2104 "chess-window.c"
							gchar* _tmp26_;
#line 481 "../src/chess-window.vala"
							_tmp26_ = g_strdup (_ ("White pawn at %1$s takes the black pawn at %2$s en passant"));
#line 481 "../src/chess-window.vala"
							_g_free0 (template);
#line 481 "../src/chess-window.vala"
							template = _tmp26_;
#line 2112 "chess-window.c"
						} else {
							gchar* _tmp27_;
#line 485 "../src/chess-window.vala"
							_tmp27_ = g_strdup (_ ("Black pawn at %1$s takes white pawn at %2$s en passant"));
#line 485 "../src/chess-window.vala"
							_g_free0 (template);
#line 485 "../src/chess-window.vala"
							template = _tmp27_;
#line 2121 "chess-window.c"
						}
					}
#line 488 "../src/chess-window.vala"
					_tmp28_ = template;
#line 488 "../src/chess-window.vala"
					_tmp29_ = start;
#line 488 "../src/chess-window.vala"
					_tmp30_ = end;
#line 488 "../src/chess-window.vala"
					_tmp31_ = g_strdup_printf (_tmp28_, _tmp29_, _tmp30_);
#line 488 "../src/chess-window.vala"
					_g_free0 (move_text);
#line 488 "../src/chess-window.vala"
					move_text = _tmp31_;
#line 450 "../src/chess-window.vala"
					_g_free0 (template);
#line 450 "../src/chess-window.vala"
					_g_free0 (end);
#line 450 "../src/chess-window.vala"
					_g_free0 (start);
#line 2142 "chess-window.c"
				}
#line 490 "../src/chess-window.vala"
				break;
#line 2146 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("san")))) {
#line 447 "../src/chess-window.vala"
		switch (0) {
#line 2152 "chess-window.c"
			default:
			{
				gchar* _tmp32_;
#line 493 "../src/chess-window.vala"
				_tmp32_ = chess_move_get_san (move);
#line 493 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 493 "../src/chess-window.vala"
				move_text = _tmp32_;
#line 494 "../src/chess-window.vala"
				break;
#line 2164 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("fan")))) {
#line 447 "../src/chess-window.vala"
		switch (0) {
#line 2170 "chess-window.c"
			default:
			{
				gchar* _tmp33_;
#line 497 "../src/chess-window.vala"
				_tmp33_ = chess_move_get_fan (move);
#line 497 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 497 "../src/chess-window.vala"
				move_text = _tmp33_;
#line 498 "../src/chess-window.vala"
				break;
#line 2182 "chess-window.c"
			}
		}
	} else {
#line 447 "../src/chess-window.vala"
		switch (0) {
#line 2188 "chess-window.c"
			default:
			{
				gchar* _tmp34_;
#line 502 "../src/chess-window.vala"
				_tmp34_ = chess_move_get_lan (move);
#line 502 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 502 "../src/chess-window.vala"
				move_text = _tmp34_;
#line 503 "../src/chess-window.vala"
				break;
#line 2200 "chess-window.c"
			}
		}
	}
#line 506 "../src/chess-window.vala"
	_tmp35_ = self->priv->history_combo;
#line 506 "../src/chess-window.vala"
	_tmp36_ = gtk_combo_box_get_model (_tmp35_);
#line 506 "../src/chess-window.vala"
	_tmp37_ = _tmp36_;
#line 506 "../src/chess-window.vala"
	_tmp38_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_list_store_get_type (), GtkListStore));
#line 506 "../src/chess-window.vala"
	model = _tmp38_;
#line 507 "../src/chess-window.vala"
	if ((move->number % 2) == 0) {
#line 507 "../src/chess-window.vala"
		_tmp39_ = 'b';
#line 2218 "chess-window.c"
	} else {
#line 507 "../src/chess-window.vala"
		_tmp39_ = 'a';
#line 2222 "chess-window.c"
	}
#line 507 "../src/chess-window.vala"
	_tmp40_ = move_text;
#line 507 "../src/chess-window.vala"
	_tmp41_ = g_strdup_printf ("%u%c. %s", (guint) ((move->number + 1) / 2), (gint) _tmp39_, _tmp40_);
#line 507 "../src/chess-window.vala"
	label = _tmp41_;
#line 508 "../src/chess-window.vala"
	_tmp42_ = model;
#line 508 "../src/chess-window.vala"
	_tmp43_ = *iter;
#line 508 "../src/chess-window.vala"
	gtk_list_store_set (_tmp42_, &_tmp43_, 0, label, -1, -1);
#line 298 "../src/chess-window.vala"
	_g_free0 (label);
#line 298 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 298 "../src/chess-window.vala"
	_g_free0 (move_text);
#line 2242 "chess-window.c"
}

static void
___lambda14_ (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 528 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 528 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 529 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 529 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2258 "chess-window.c"
}

static void
____lambda14__chess_clock_tick (ChessClock* _sender,
                                gpointer self)
{
#line 527 "../src/chess-window.vala"
	___lambda14_ ((ChessWindow*) self);
#line 2267 "chess-window.c"
}

void
chess_window_start_game (ChessWindow* self)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkListStore* _tmp4_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GtkComboBox* _tmp9_;
	GtkTreeIter _tmp10_;
	GtkDrawingArea* _tmp11_;
	GtkDrawingArea* _tmp12_;
	ChessGame* _tmp13_;
	ChessGame* _tmp14_;
	ChessClock* _tmp15_;
	ChessClock* _tmp16_;
#line 511 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_combo;
#line 513 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 513 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 513 "../src/chess-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 513 "../src/chess-window.vala"
	model = _tmp3_;
#line 514 "../src/chess-window.vala"
	_tmp4_ = model;
#line 514 "../src/chess-window.vala"
	gtk_list_store_clear (_tmp4_);
#line 516 "../src/chess-window.vala"
	_tmp5_ = model;
#line 516 "../src/chess-window.vala"
	gtk_list_store_append (_tmp5_, &_tmp6_);
#line 516 "../src/chess-window.vala"
	iter = _tmp6_;
#line 517 "../src/chess-window.vala"
	_tmp7_ = model;
#line 517 "../src/chess-window.vala"
	_tmp8_ = iter;
#line 517 "../src/chess-window.vala"
	gtk_list_store_set (_tmp7_, &_tmp8_, 0, _ ("Game Start"), 1, 0, -1, -1);
#line 520 "../src/chess-window.vala"
	_tmp9_ = self->priv->history_combo;
#line 520 "../src/chess-window.vala"
	_tmp10_ = iter;
#line 520 "../src/chess-window.vala"
	gtk_combo_box_set_active_iter (_tmp9_, &_tmp10_);
#line 522 "../src/chess-window.vala"
	_tmp11_ = self->priv->white_time_label;
#line 522 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp11_);
#line 523 "../src/chess-window.vala"
	_tmp12_ = self->priv->black_time_label;
#line 523 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp12_);
#line 525 "../src/chess-window.vala"
	_tmp13_ = chess_window_get_game (self);
#line 525 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 525 "../src/chess-window.vala"
	_tmp15_ = chess_game_get_clock (_tmp14_);
#line 525 "../src/chess-window.vala"
	_tmp16_ = _tmp15_;
#line 525 "../src/chess-window.vala"
	if (_tmp16_ != NULL) {
#line 2344 "chess-window.c"
		ChessGame* _tmp17_;
		ChessGame* _tmp18_;
		ChessClock* _tmp19_;
		ChessClock* _tmp20_;
#line 527 "../src/chess-window.vala"
		_tmp17_ = chess_window_get_game (self);
#line 527 "../src/chess-window.vala"
		_tmp18_ = _tmp17_;
#line 527 "../src/chess-window.vala"
		_tmp19_ = chess_game_get_clock (_tmp18_);
#line 527 "../src/chess-window.vala"
		_tmp20_ = _tmp19_;
#line 527 "../src/chess-window.vala"
		g_signal_connect_object (_tmp20_, "tick", (GCallback) ____lambda14__chess_clock_tick, self, 0);
#line 2359 "chess-window.c"
	}
#line 511 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2363 "chess-window.c"
}

void
chess_window_move (ChessWindow* self,
                   ChessMove* m)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	GtkListStore* model = NULL;
	GtkComboBox* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkTreeIter _tmp10_;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
#line 534 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/chess-window.vala"
	g_return_if_fail (m != NULL);
#line 537 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 537 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 537 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp1_, -1);
#line 539 "../src/chess-window.vala"
	_tmp2_ = self->priv->history_combo;
#line 539 "../src/chess-window.vala"
	_tmp3_ = gtk_combo_box_get_model (_tmp2_);
#line 539 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 539 "../src/chess-window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_list_store_get_type (), GtkListStore));
#line 539 "../src/chess-window.vala"
	model = _tmp5_;
#line 541 "../src/chess-window.vala"
	_tmp6_ = model;
#line 541 "../src/chess-window.vala"
	gtk_list_store_append (_tmp6_, &_tmp7_);
#line 541 "../src/chess-window.vala"
	iter = _tmp7_;
#line 542 "../src/chess-window.vala"
	_tmp8_ = model;
#line 542 "../src/chess-window.vala"
	_tmp9_ = iter;
#line 542 "../src/chess-window.vala"
	gtk_list_store_set (_tmp8_, &_tmp9_, 1, m->number, -1, -1);
#line 543 "../src/chess-window.vala"
	_tmp10_ = iter;
#line 543 "../src/chess-window.vala"
	chess_window_set_move_text (self, &_tmp10_, m);
#line 546 "../src/chess-window.vala"
	_tmp11_ = chess_window_get_game (self);
#line 546 "../src/chess-window.vala"
	_tmp12_ = _tmp11_;
#line 546 "../src/chess-window.vala"
	_tmp13_ = chess_game_get_n_moves (_tmp12_);
#line 546 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 546 "../src/chess-window.vala"
	if (((guint) m->number) == _tmp14_) {
#line 2433 "chess-window.c"
		GtkComboBox* _tmp15_;
		GtkTreeIter _tmp16_;
#line 547 "../src/chess-window.vala"
		_tmp15_ = self->priv->history_combo;
#line 547 "../src/chess-window.vala"
		_tmp16_ = iter;
#line 547 "../src/chess-window.vala"
		gtk_combo_box_set_active_iter (_tmp15_, &_tmp16_);
#line 2442 "chess-window.c"
	}
#line 534 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2446 "chess-window.c"
}

void
chess_window_undo (ChessWindow* self)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp4_ = {0};
	ChessScene* _tmp5_;
	ChessScene* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkComboBox* _tmp8_;
	GtkTreeIter _tmp9_;
	ChessView* _tmp10_;
#line 550 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 553 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_combo;
#line 553 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 553 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 553 "../src/chess-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 553 "../src/chess-window.vala"
	model = _tmp3_;
#line 555 "../src/chess-window.vala"
	gtk_tree_model_iter_nth_child ((GtkTreeModel*) model, &_tmp4_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) model, NULL) - 1);
#line 555 "../src/chess-window.vala"
	iter = _tmp4_;
#line 556 "../src/chess-window.vala"
	gtk_list_store_remove (model, &iter);
#line 559 "../src/chess-window.vala"
	_tmp5_ = chess_window_get_scene (self);
#line 559 "../src/chess-window.vala"
	_tmp6_ = _tmp5_;
#line 559 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp6_, -1);
#line 562 "../src/chess-window.vala"
	gtk_tree_model_iter_nth_child ((GtkTreeModel*) model, &_tmp7_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) model, NULL) - 1);
#line 562 "../src/chess-window.vala"
	iter = _tmp7_;
#line 563 "../src/chess-window.vala"
	_tmp8_ = self->priv->history_combo;
#line 563 "../src/chess-window.vala"
	_tmp9_ = iter;
#line 563 "../src/chess-window.vala"
	gtk_combo_box_set_active_iter (_tmp8_, &_tmp9_);
#line 564 "../src/chess-window.vala"
	_tmp10_ = self->priv->_view;
#line 564 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp10_);
#line 550 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2505 "chess-window.c"
}

void
chess_window_end_game (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 567 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 569 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 570 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 570 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2523 "chess-window.c"
}

ChessWindowLayoutMode
chess_window_get_layout_mode (ChessWindow* self)
{
	ChessWindowLayoutMode result;
#line 24 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/chess-window.vala"
	result = self->priv->_layout_mode;
#line 24 "../src/chess-window.vala"
	return result;
#line 2536 "chess-window.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 26 "../src/chess-window.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 26 "../src/chess-window.vala"
	return _data3_;
#line 2546 "chess-window.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 26 "../src/chess-window.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2556 "chess-window.c"
		ChessWindow* self;
#line 26 "../src/chess-window.vala"
		self = _data3_->self;
#line 26 "../src/chess-window.vala"
		_g_object_unref0 (self);
#line 26 "../src/chess-window.vala"
		g_slice_free (Block3Data, _data3_);
#line 2564 "chess-window.c"
	}
}

static gboolean
_chess_window_layout_mode___lambda23_ (Block3Data* _data3_)
{
	ChessWindow* self;
	GtkOrientation _tmp0_ = 0;
	GtkBox* _tmp1_;
	gboolean result = FALSE;
#line 33 "../src/chess-window.vala"
	self = _data3_->self;
#line 34 "../src/chess-window.vala"
	if (_data3_->value == CHESS_WINDOW_LAYOUT_MODE_NORMAL) {
#line 34 "../src/chess-window.vala"
		_tmp0_ = GTK_ORIENTATION_HORIZONTAL;
#line 2581 "chess-window.c"
	} else {
#line 34 "../src/chess-window.vala"
		_tmp0_ = GTK_ORIENTATION_VERTICAL;
#line 2585 "chess-window.c"
	}
#line 34 "../src/chess-window.vala"
	_tmp1_ = self->priv->navigation_box;
#line 34 "../src/chess-window.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp1_, _tmp0_);
#line 35 "../src/chess-window.vala"
	result = G_SOURCE_REMOVE;
#line 35 "../src/chess-window.vala"
	return result;
#line 2595 "chess-window.c"
}

static gboolean
__chess_window_layout_mode___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = _chess_window_layout_mode___lambda23_ (self);
#line 33 "../src/chess-window.vala"
	return result;
#line 2605 "chess-window.c"
}

static void
chess_window_set_layout_mode (ChessWindow* self,
                              ChessWindowLayoutMode value)
{
	Block3Data* _data3_;
#line 26 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/chess-window.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 26 "../src/chess-window.vala"
	_data3_->_ref_count_ = 1;
#line 26 "../src/chess-window.vala"
	_data3_->self = g_object_ref (self);
#line 26 "../src/chess-window.vala"
	_data3_->value = value;
#line 28 "../src/chess-window.vala"
	if (self->priv->_layout_mode == _data3_->value) {
#line 29 "../src/chess-window.vala"
		block3_data_unref (_data3_);
#line 29 "../src/chess-window.vala"
		_data3_ = NULL;
#line 29 "../src/chess-window.vala"
		return;
#line 2631 "chess-window.c"
	}
#line 31 "../src/chess-window.vala"
	self->priv->_layout_mode = _data3_->value;
#line 33 "../src/chess-window.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __chess_window_layout_mode___lambda23__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 26 "../src/chess-window.vala"
	block3_data_unref (_data3_);
#line 26 "../src/chess-window.vala"
	_data3_ = NULL;
#line 26 "../src/chess-window.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_window_properties[CHESS_WINDOW_LAYOUT_MODE_PROPERTY]);
#line 2643 "chess-window.c"
}

ChessView*
chess_window_get_view (ChessWindow* self)
{
	ChessView* result;
	ChessView* _tmp0_;
#line 42 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 42 "../src/chess-window.vala"
	result = _tmp0_;
#line 42 "../src/chess-window.vala"
	return result;
#line 2659 "chess-window.c"
}

static void
chess_window_set_view (ChessWindow* self,
                       ChessView* value)
{
	ChessView* old_value;
#line 42 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/chess-window.vala"
	old_value = chess_window_get_view (self);
#line 42 "../src/chess-window.vala"
	if (old_value != value) {
#line 2673 "chess-window.c"
		ChessView* _tmp0_;
#line 42 "../src/chess-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/chess-window.vala"
		_g_object_unref0 (self->priv->_view);
#line 42 "../src/chess-window.vala"
		self->priv->_view = _tmp0_;
#line 42 "../src/chess-window.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY]);
#line 2683 "chess-window.c"
	}
}

ChessScene*
chess_window_get_scene (ChessWindow* self)
{
	ChessScene* result;
	ChessView* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
#line 47 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 47 "../src/chess-window.vala"
	_tmp1_ = chess_view_get_scene (_tmp0_);
#line 47 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 47 "../src/chess-window.vala"
	result = _tmp2_;
#line 47 "../src/chess-window.vala"
	return result;
#line 2706 "chess-window.c"
}

ChessGame*
chess_window_get_game (ChessWindow* self)
{
	ChessGame* result;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
#line 52 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 52 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 52 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 52 "../src/chess-window.vala"
	result = _tmp3_;
#line 52 "../src/chess-window.vala"
	return result;
#line 2731 "chess-window.c"
}

static void
chess_window_class_init (ChessWindowClass * klass,
                         gpointer klass_data)
{
#line 14 "../src/chess-window.vala"
	chess_window_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/chess-window.vala"
	g_type_class_adjust_private_offset (klass, &ChessWindow_private_offset);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_window_get_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_window_set_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_window_finalize;
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_LAYOUT_MODE_PROPERTY, chess_window_properties[CHESS_WINDOW_LAYOUT_MODE_PROPERTY] = g_param_spec_enum ("layout-mode", "layout-mode", "layout-mode", CHESS_WINDOW_TYPE_LAYOUT_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_VIEW_PROPERTY, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_CHESS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_SCENE_PROPERTY, chess_window_properties[CHESS_WINDOW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_GAME_PROPERTY, chess_window_properties[CHESS_WINDOW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Chess/ui/chess-window.ui");
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, main_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_bar", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, info_bar));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_bar_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, info_bar_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_resume_button", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, pause_resume_button));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "navigation_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, navigation_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "history_combo", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, history_combo));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, clock_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "white_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, white_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "black_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, black_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "history_combo_changed_cb", G_CALLBACK(_chess_window_history_combo_changed_cb_gtk_combo_box_changed));
#line 2778 "chess-window.c"
}

static void
chess_window_instance_init (ChessWindow * self,
                            gpointer klass)
{
#line 14 "../src/chess-window.vala"
	self->priv = chess_window_get_instance_private (self);
#line 21 "../src/chess-window.vala"
	self->priv->_layout_mode = CHESS_WINDOW_LAYOUT_MODE_NORMAL;
#line 14 "../src/chess-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2791 "chess-window.c"
}

static void
chess_window_finalize (GObject * obj)
{
	ChessWindow * self;
#line 14 "../src/chess-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_WINDOW, ChessWindow);
#line 40 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->_view);
#line 55 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (chess_window_parent_class)->finalize (obj);
#line 2806 "chess-window.c"
}

static GType
chess_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessWindow), 0, (GInstanceInitFunc) chess_window_instance_init, NULL };
	GType chess_window_type_id;
	chess_window_type_id = g_type_register_static (gtk_application_window_get_type (), "ChessWindow", &g_define_type_info, 0);
	ChessWindow_private_offset = g_type_add_instance_private (chess_window_type_id, sizeof (ChessWindowPrivate));
	return chess_window_type_id;
}

GType
chess_window_get_type (void)
{
	static volatile gsize chess_window_type_id__volatile = 0;
	if (g_once_init_enter (&chess_window_type_id__volatile)) {
		GType chess_window_type_id;
		chess_window_type_id = chess_window_get_type_once ();
		g_once_init_leave (&chess_window_type_id__volatile, chess_window_type_id);
	}
	return chess_window_type_id__volatile;
}

static void
_vala_chess_window_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_LAYOUT_MODE_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_enum (value, chess_window_get_layout_mode (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_view (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_SCENE_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_scene (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_GAME_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_game (self));
#line 14 "../src/chess-window.vala"
		break;
#line 2865 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2871 "chess-window.c"
	}
}

static void
_vala_chess_window_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_LAYOUT_MODE_PROPERTY:
#line 14 "../src/chess-window.vala"
		chess_window_set_layout_mode (self, g_value_get_enum (value));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		chess_window_set_view (self, g_value_get_object (value));
#line 14 "../src/chess-window.vala"
		break;
#line 2897 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2903 "chess-window.c"
	}
}

