/* preferences-dialog.c generated by valac 0.52.10, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2020 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "libengine.h"
#include <stdlib.h>
#include <string.h>
#include "libchess.h"
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	GList* ai_profiles;
	guint save_duration_timeout;
	GtkCheckButton* show_numbering_check;
	GtkCheckButton* show_move_hints_check;
	GtkComboBox* side_combo;
	GtkComboBox* difficulty_combo;
	GtkComboBox* opponent_combo;
	GtkListStore* opponent_model;
	GtkAdjustment* duration_adjustment;
	GtkAdjustment* timer_increment_adjustment;
	GtkBox* custom_duration_box;
	GtkBox* timer_increment_box;
	GtkComboBox* custom_duration_units_combo;
	GtkLabel* timer_increment_label;
	GtkComboBox* timer_increment_units_combo;
	GtkComboBox* clock_type_combo;
	GtkComboBox* duration_combo;
	GtkComboBox* orientation_combo;
	GtkComboBox* move_format_combo;
	GtkComboBox* piece_style_combo;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
static gboolean preferences_dialog_save_duration_cb (PreferencesDialog* self);
PreferencesDialog* preferences_dialog_new (GtkWindow* window,
                                           GSettings* settings,
                                           GList* ai_profiles);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GtkWindow* window,
                                                 GSettings* settings,
                                                 GList* ai_profiles);
static void preferences_dialog_set_combo (PreferencesDialog* self,
                                   GtkComboBox* combo,
                                   gint value_index,
                                   const gchar* value);
static void preferences_dialog_set_duration (PreferencesDialog* self,
                                      gint duration,
                                      gboolean simplify);
static void preferences_dialog_set_clock_type (PreferencesDialog* self,
                                        gint clock_type);
static void preferences_dialog_set_timer_increment (PreferencesDialog* self,
                                             gint timer_increment);
static gchar* preferences_dialog_get_combo (PreferencesDialog* self,
                                     GtkComboBox* combo,
                                     gint value_index);
static void preferences_dialog_side_combo_changed_cb (PreferencesDialog* self,
                                               GtkComboBox* combo);
static void _preferences_dialog_side_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void preferences_dialog_opponent_combo_changed_cb (PreferencesDialog* self,
                                                   GtkComboBox* combo);
static void _preferences_dialog_opponent_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void preferences_dialog_difficulty_combo_changed_cb (PreferencesDialog* self,
                                                     GtkComboBox* combo);
static void _preferences_dialog_difficulty_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                            gpointer self);
static void preferences_dialog_clock_type_changed_cb (PreferencesDialog* self,
                                               GtkComboBox* combo);
static void preferences_dialog_timer_increment_units_changed_cb (PreferencesDialog* self,
                                                          GtkWidget* widget);
static gint preferences_dialog_get_duration (PreferencesDialog* self);
static void preferences_dialog_duration_changed_cb (PreferencesDialog* self,
                                             GtkAdjustment* adjustment);
static void preferences_dialog_save_duration (PreferencesDialog* self);
static void _preferences_dialog_duration_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                           gpointer self);
static void preferences_dialog_duration_units_changed_cb (PreferencesDialog* self,
                                                   GtkWidget* widget);
static void _preferences_dialog_duration_units_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void _preferences_dialog_timer_increment_units_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                 gpointer self);
static gboolean _preferences_dialog_save_duration_cb_gsource_func (gpointer self);
static void preferences_dialog_duration_combo_changed_cb (PreferencesDialog* self,
                                                   GtkComboBox* combo);
static void _preferences_dialog_duration_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void _preferences_dialog_clock_type_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void preferences_dialog_piece_style_combo_changed_cb (PreferencesDialog* self,
                                                      GtkComboBox* combo);
static void _preferences_dialog_piece_style_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                             gpointer self);
static void preferences_dialog_move_format_combo_changed_cb (PreferencesDialog* self,
                                                      GtkComboBox* combo);
static void _preferences_dialog_move_format_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                             gpointer self);
static void preferences_dialog_orientation_combo_changed_cb (PreferencesDialog* self,
                                                      GtkComboBox* combo);
static void _preferences_dialog_orientation_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                             gpointer self);
static void preferences_dialog_finalize (GObject * obj);
static GType preferences_dialog_get_type_once (void);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 168 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GtkWindow* window,
                              GSettings* settings,
                              GList* ai_profiles)
{
	PreferencesDialog * self = NULL;
	GSettings* _tmp0_;
	GtkCheckButton* _tmp1_;
	GtkCheckButton* _tmp2_;
	GtkComboBox* _tmp3_;
	GtkComboBox* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* opponent_name = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GtkComboBox* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GtkComboBox* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	GtkComboBox* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GtkComboBox* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GtkComboBox* _tmp48_;
#line 57 "../src/preferences-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 57 "../src/preferences-dialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 57 "../src/preferences-dialog.vala"
	self = (PreferencesDialog*) g_object_new (object_type, NULL);
#line 59 "../src/preferences-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 60 "../src/preferences-dialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 62 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 62 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 62 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp0_;
#line 63 "../src/preferences-dialog.vala"
	self->priv->ai_profiles = ai_profiles;
#line 65 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->show_numbering_check;
#line 65 "../src/preferences-dialog.vala"
	g_settings_bind (settings, "show-numbering", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 67 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->show_move_hints_check;
#line 67 "../src/preferences-dialog.vala"
	g_settings_bind (settings, "show-move-hints", (GObject*) _tmp2_, "active", G_SETTINGS_BIND_DEFAULT);
#line 70 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->side_combo;
#line 70 "../src/preferences-dialog.vala"
	gtk_combo_box_set_active (_tmp3_, g_settings_get_enum (settings, "play-as"));
#line 71 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->difficulty_combo;
#line 71 "../src/preferences-dialog.vala"
	_tmp5_ = g_settings_get_string (settings, "difficulty");
#line 71 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 71 "../src/preferences-dialog.vala"
	preferences_dialog_set_combo (self, _tmp4_, 1, _tmp6_);
#line 71 "../src/preferences-dialog.vala"
	_g_free0 (_tmp6_);
#line 73 "../src/preferences-dialog.vala"
	_tmp7_ = g_settings_get_string (settings, "opponent");
#line 73 "../src/preferences-dialog.vala"
	opponent_name = _tmp7_;
#line 74 "../src/preferences-dialog.vala"
	_tmp8_ = opponent_name;
#line 74 "../src/preferences-dialog.vala"
	if (g_strcmp0 (_tmp8_, "human") == 0) {
#line 251 "preferences-dialog.c"
		GtkComboBox* _tmp9_;
#line 75 "../src/preferences-dialog.vala"
		_tmp9_ = self->priv->opponent_combo;
#line 75 "../src/preferences-dialog.vala"
		gtk_combo_box_set_active (_tmp9_, 0);
#line 257 "preferences-dialog.c"
	}
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
#line 77 "../src/preferences-dialog.vala"
		p_collection = ai_profiles;
#line 77 "../src/preferences-dialog.vala"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 266 "preferences-dialog.c"
			AIProfile* _tmp10_;
			AIProfile* p = NULL;
#line 77 "../src/preferences-dialog.vala"
			_tmp10_ = _g_object_ref0 ((AIProfile*) p_it->data);
#line 77 "../src/preferences-dialog.vala"
			p = _tmp10_;
#line 273 "preferences-dialog.c"
			{
				GtkTreeIter iter = {0};
				GtkListStore* _tmp11_;
				GtkTreeIter _tmp12_ = {0};
				GtkListStore* _tmp13_;
				GtkTreeIter _tmp14_;
				AIProfile* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				AIProfile* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				gboolean _tmp21_ = FALSE;
				AIProfile* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
#line 80 "../src/preferences-dialog.vala"
				_tmp11_ = self->priv->opponent_model;
#line 80 "../src/preferences-dialog.vala"
				gtk_list_store_append (_tmp11_, &_tmp12_);
#line 80 "../src/preferences-dialog.vala"
				iter = _tmp12_;
#line 81 "../src/preferences-dialog.vala"
				_tmp13_ = self->priv->opponent_model;
#line 81 "../src/preferences-dialog.vala"
				_tmp14_ = iter;
#line 81 "../src/preferences-dialog.vala"
				_tmp15_ = p;
#line 81 "../src/preferences-dialog.vala"
				_tmp16_ = ai_profile_get_name (_tmp15_);
#line 81 "../src/preferences-dialog.vala"
				_tmp17_ = _tmp16_;
#line 81 "../src/preferences-dialog.vala"
				_tmp18_ = p;
#line 81 "../src/preferences-dialog.vala"
				_tmp19_ = ai_profile_get_name (_tmp18_);
#line 81 "../src/preferences-dialog.vala"
				_tmp20_ = _tmp19_;
#line 81 "../src/preferences-dialog.vala"
				gtk_list_store_set (_tmp13_, &_tmp14_, 0, _tmp17_, 1, _tmp20_, -1, -1);
#line 82 "../src/preferences-dialog.vala"
				_tmp22_ = p;
#line 82 "../src/preferences-dialog.vala"
				_tmp23_ = ai_profile_get_name (_tmp22_);
#line 82 "../src/preferences-dialog.vala"
				_tmp24_ = _tmp23_;
#line 82 "../src/preferences-dialog.vala"
				_tmp25_ = opponent_name;
#line 82 "../src/preferences-dialog.vala"
				if (g_strcmp0 (_tmp24_, _tmp25_) == 0) {
#line 82 "../src/preferences-dialog.vala"
					_tmp21_ = TRUE;
#line 327 "preferences-dialog.c"
				} else {
					gboolean _tmp26_ = FALSE;
					const gchar* _tmp27_;
#line 82 "../src/preferences-dialog.vala"
					_tmp27_ = opponent_name;
#line 82 "../src/preferences-dialog.vala"
					if (g_strcmp0 (_tmp27_, "") == 0) {
#line 335 "preferences-dialog.c"
						GtkComboBox* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
#line 82 "../src/preferences-dialog.vala"
						_tmp28_ = self->priv->opponent_combo;
#line 82 "../src/preferences-dialog.vala"
						_tmp29_ = gtk_combo_box_get_active (_tmp28_);
#line 82 "../src/preferences-dialog.vala"
						_tmp30_ = _tmp29_;
#line 82 "../src/preferences-dialog.vala"
						_tmp26_ = _tmp30_ == -1;
#line 347 "preferences-dialog.c"
					} else {
#line 82 "../src/preferences-dialog.vala"
						_tmp26_ = FALSE;
#line 351 "preferences-dialog.c"
					}
#line 82 "../src/preferences-dialog.vala"
					_tmp21_ = _tmp26_;
#line 355 "preferences-dialog.c"
				}
#line 82 "../src/preferences-dialog.vala"
				if (_tmp21_) {
#line 359 "preferences-dialog.c"
					GtkComboBox* _tmp31_;
					GtkTreeIter _tmp32_;
#line 83 "../src/preferences-dialog.vala"
					_tmp31_ = self->priv->opponent_combo;
#line 83 "../src/preferences-dialog.vala"
					_tmp32_ = iter;
#line 83 "../src/preferences-dialog.vala"
					gtk_combo_box_set_active_iter (_tmp31_, &_tmp32_);
#line 368 "preferences-dialog.c"
				}
#line 77 "../src/preferences-dialog.vala"
				_g_object_unref0 (p);
#line 372 "preferences-dialog.c"
			}
		}
	}
#line 86 "../src/preferences-dialog.vala"
	_tmp33_ = self->priv->opponent_combo;
#line 86 "../src/preferences-dialog.vala"
	_tmp34_ = gtk_combo_box_get_active (_tmp33_);
#line 86 "../src/preferences-dialog.vala"
	_tmp35_ = _tmp34_;
#line 86 "../src/preferences-dialog.vala"
	if (_tmp35_ == -1) {
#line 384 "preferences-dialog.c"
		GtkComboBox* _tmp36_;
#line 88 "../src/preferences-dialog.vala"
		_tmp36_ = self->priv->opponent_combo;
#line 88 "../src/preferences-dialog.vala"
		gtk_combo_box_set_active (_tmp36_, 0);
#line 89 "../src/preferences-dialog.vala"
		g_settings_set_string (settings, "opponent", "human");
#line 392 "preferences-dialog.c"
	}
#line 92 "../src/preferences-dialog.vala"
	preferences_dialog_set_duration (self, g_settings_get_int (settings, "duration"), TRUE);
#line 94 "../src/preferences-dialog.vala"
	_tmp37_ = g_settings_get_string (settings, "clock-type");
#line 94 "../src/preferences-dialog.vala"
	_tmp38_ = _tmp37_;
#line 94 "../src/preferences-dialog.vala"
	preferences_dialog_set_clock_type (self, (gint) clock_type_string_to_enum (_tmp38_));
#line 94 "../src/preferences-dialog.vala"
	_g_free0 (_tmp38_);
#line 95 "../src/preferences-dialog.vala"
	preferences_dialog_set_timer_increment (self, g_settings_get_int (settings, "timer-increment"));
#line 97 "../src/preferences-dialog.vala"
	_tmp39_ = self->priv->orientation_combo;
#line 97 "../src/preferences-dialog.vala"
	_tmp40_ = g_settings_get_string (settings, "board-side");
#line 97 "../src/preferences-dialog.vala"
	_tmp41_ = _tmp40_;
#line 97 "../src/preferences-dialog.vala"
	preferences_dialog_set_combo (self, _tmp39_, 1, _tmp41_);
#line 97 "../src/preferences-dialog.vala"
	_g_free0 (_tmp41_);
#line 98 "../src/preferences-dialog.vala"
	_tmp42_ = self->priv->move_format_combo;
#line 98 "../src/preferences-dialog.vala"
	_tmp43_ = g_settings_get_string (settings, "move-format");
#line 98 "../src/preferences-dialog.vala"
	_tmp44_ = _tmp43_;
#line 98 "../src/preferences-dialog.vala"
	preferences_dialog_set_combo (self, _tmp42_, 1, _tmp44_);
#line 98 "../src/preferences-dialog.vala"
	_g_free0 (_tmp44_);
#line 99 "../src/preferences-dialog.vala"
	_tmp45_ = self->priv->piece_style_combo;
#line 99 "../src/preferences-dialog.vala"
	_tmp46_ = g_settings_get_string (settings, "piece-theme");
#line 99 "../src/preferences-dialog.vala"
	_tmp47_ = _tmp46_;
#line 99 "../src/preferences-dialog.vala"
	preferences_dialog_set_combo (self, _tmp45_, 1, _tmp47_);
#line 99 "../src/preferences-dialog.vala"
	_g_free0 (_tmp47_);
#line 102 "../src/preferences-dialog.vala"
	_tmp48_ = self->priv->opponent_combo;
#line 102 "../src/preferences-dialog.vala"
	if (gtk_combo_box_get_active (_tmp48_) == 0) {
#line 440 "preferences-dialog.c"
		GtkComboBox* _tmp49_;
		GtkComboBox* _tmp50_;
#line 104 "../src/preferences-dialog.vala"
		_tmp49_ = self->priv->side_combo;
#line 104 "../src/preferences-dialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp49_, FALSE);
#line 105 "../src/preferences-dialog.vala"
		_tmp50_ = self->priv->difficulty_combo;
#line 105 "../src/preferences-dialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp50_, FALSE);
#line 451 "preferences-dialog.c"
	}
#line 57 "../src/preferences-dialog.vala"
	_g_free0 (opponent_name);
#line 57 "../src/preferences-dialog.vala"
	return self;
#line 457 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_new (GtkWindow* window,
                        GSettings* settings,
                        GList* ai_profiles)
{
#line 57 "../src/preferences-dialog.vala"
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, window, settings, ai_profiles);
#line 467 "preferences-dialog.c"
}

static void
preferences_dialog_set_combo (PreferencesDialog* self,
                              GtkComboBox* combo,
                              gint value_index,
                              const gchar* value)
{
	GtkTreeIter iter = {0};
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
#line 118 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 118 "../src/preferences-dialog.vala"
	g_return_if_fail (value != NULL);
#line 121 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_combo_box_get_model (combo);
#line 121 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 121 "../src/preferences-dialog.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 121 "../src/preferences-dialog.vala"
	model = _tmp2_;
#line 122 "../src/preferences-dialog.vala"
	_tmp3_ = model;
#line 122 "../src/preferences-dialog.vala"
	_tmp5_ = gtk_tree_model_get_iter_first (_tmp3_, &_tmp4_);
#line 122 "../src/preferences-dialog.vala"
	iter = _tmp4_;
#line 122 "../src/preferences-dialog.vala"
	if (!_tmp5_) {
#line 123 "../src/preferences-dialog.vala"
		_g_object_unref0 (model);
#line 123 "../src/preferences-dialog.vala"
		return;
#line 510 "preferences-dialog.c"
	}
	{
		gboolean _tmp6_ = FALSE;
#line 124 "../src/preferences-dialog.vala"
		_tmp6_ = TRUE;
#line 124 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 518 "preferences-dialog.c"
			gchar* v = NULL;
			GtkTreeModel* _tmp9_;
			GtkTreeIter _tmp10_;
			gchar* _tmp11_ = NULL;
			const gchar* _tmp12_;
#line 124 "../src/preferences-dialog.vala"
			if (!_tmp6_) {
#line 526 "preferences-dialog.c"
				GtkTreeModel* _tmp7_;
				gboolean _tmp8_;
#line 133 "../src/preferences-dialog.vala"
				_tmp7_ = model;
#line 133 "../src/preferences-dialog.vala"
				_tmp8_ = gtk_tree_model_iter_next (_tmp7_, &iter);
#line 133 "../src/preferences-dialog.vala"
				if (!_tmp8_) {
#line 133 "../src/preferences-dialog.vala"
					break;
#line 537 "preferences-dialog.c"
				}
			}
#line 124 "../src/preferences-dialog.vala"
			_tmp6_ = FALSE;
#line 127 "../src/preferences-dialog.vala"
			_tmp9_ = model;
#line 127 "../src/preferences-dialog.vala"
			_tmp10_ = iter;
#line 127 "../src/preferences-dialog.vala"
			gtk_tree_model_get (_tmp9_, &_tmp10_, value_index, &_tmp11_, -1, -1);
#line 127 "../src/preferences-dialog.vala"
			_g_free0 (v);
#line 127 "../src/preferences-dialog.vala"
			v = _tmp11_;
#line 128 "../src/preferences-dialog.vala"
			_tmp12_ = v;
#line 128 "../src/preferences-dialog.vala"
			if (g_strcmp0 (_tmp12_, value) == 0) {
#line 556 "preferences-dialog.c"
				GtkTreeIter _tmp13_;
#line 130 "../src/preferences-dialog.vala"
				_tmp13_ = iter;
#line 130 "../src/preferences-dialog.vala"
				gtk_combo_box_set_active_iter (combo, &_tmp13_);
#line 131 "../src/preferences-dialog.vala"
				_g_free0 (v);
#line 131 "../src/preferences-dialog.vala"
				_g_object_unref0 (model);
#line 131 "../src/preferences-dialog.vala"
				return;
#line 568 "preferences-dialog.c"
			}
#line 124 "../src/preferences-dialog.vala"
			_g_free0 (v);
#line 572 "preferences-dialog.c"
		}
	}
#line 118 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 577 "preferences-dialog.c"
}

static gchar*
preferences_dialog_get_combo (PreferencesDialog* self,
                              GtkComboBox* combo,
                              gint value_index)
{
	gchar* value = NULL;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* result = NULL;
#line 136 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 136 "../src/preferences-dialog.vala"
	g_return_val_if_fail (combo != NULL, NULL);
#line 140 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 140 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 140 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 141 "../src/preferences-dialog.vala"
		result = NULL;
#line 141 "../src/preferences-dialog.vala"
		_g_free0 (value);
#line 141 "../src/preferences-dialog.vala"
		return result;
#line 610 "preferences-dialog.c"
	}
#line 142 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 142 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 142 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 142 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, value_index, &_tmp5_, -1, -1);
#line 142 "../src/preferences-dialog.vala"
	_g_free0 (value);
#line 142 "../src/preferences-dialog.vala"
	value = _tmp5_;
#line 143 "../src/preferences-dialog.vala"
	result = value;
#line 143 "../src/preferences-dialog.vala"
	return result;
#line 628 "preferences-dialog.c"
}

static void
preferences_dialog_side_combo_changed_cb (PreferencesDialog* self,
                                          GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gint player = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gint _tmp5_ = 0;
	GSettings* _tmp6_;
#line 147 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 150 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 150 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 150 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 151 "../src/preferences-dialog.vala"
		return;
#line 656 "preferences-dialog.c"
	}
#line 153 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 153 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 153 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 153 "../src/preferences-dialog.vala"
	player = _tmp5_;
#line 155 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->settings;
#line 155 "../src/preferences-dialog.vala"
	g_settings_set_enum (_tmp6_, "play-as", player);
#line 672 "preferences-dialog.c"
}

static void
_preferences_dialog_side_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_side_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 681 "preferences-dialog.c"
}

static void
preferences_dialog_opponent_combo_changed_cb (PreferencesDialog* self,
                                              GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* opponent = NULL;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gchar* _tmp5_ = NULL;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
	gboolean vs_human = FALSE;
	GtkComboBox* _tmp8_;
	GtkComboBox* _tmp9_;
#line 159 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 162 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 162 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 162 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 163 "../src/preferences-dialog.vala"
		return;
#line 713 "preferences-dialog.c"
	}
#line 165 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 165 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 165 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 165 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 165 "../src/preferences-dialog.vala"
	_g_free0 (opponent);
#line 165 "../src/preferences-dialog.vala"
	opponent = _tmp5_;
#line 166 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->settings;
#line 166 "../src/preferences-dialog.vala"
	_tmp7_ = opponent;
#line 166 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp6_, "opponent", _tmp7_);
#line 167 "../src/preferences-dialog.vala"
	vs_human = gtk_combo_box_get_active (combo) == 0;
#line 168 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->side_combo;
#line 168 "../src/preferences-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !vs_human);
#line 169 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->difficulty_combo;
#line 169 "../src/preferences-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, !vs_human);
#line 159 "../src/preferences-dialog.vala"
	_g_free0 (opponent);
#line 745 "preferences-dialog.c"
}

static void
_preferences_dialog_opponent_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_opponent_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 754 "preferences-dialog.c"
}

static void
preferences_dialog_difficulty_combo_changed_cb (PreferencesDialog* self,
                                                GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* difficulty = NULL;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gchar* _tmp5_ = NULL;
	GSettings* _tmp6_;
	const gchar* _tmp7_;
#line 173 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 176 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 176 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 176 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 177 "../src/preferences-dialog.vala"
		return;
#line 783 "preferences-dialog.c"
	}
#line 179 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 179 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 179 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 179 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 179 "../src/preferences-dialog.vala"
	_g_free0 (difficulty);
#line 179 "../src/preferences-dialog.vala"
	difficulty = _tmp5_;
#line 180 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->settings;
#line 180 "../src/preferences-dialog.vala"
	_tmp7_ = difficulty;
#line 180 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp6_, "difficulty", _tmp7_);
#line 173 "../src/preferences-dialog.vala"
	_g_free0 (difficulty);
#line 805 "preferences-dialog.c"
}

static void
_preferences_dialog_difficulty_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_difficulty_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 814 "preferences-dialog.c"
}

static void
preferences_dialog_set_clock_type (PreferencesDialog* self,
                                   gint clock_type)
{
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter iter = {0};
	GtkTreeIter active_iter_clock_type = {0};
	GtkTreeIter _tmp4_ = {0};
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean _tmp7_;
	GtkComboBox* _tmp15_;
	GtkTreeIter _tmp16_;
	GtkComboBox* _tmp17_;
#line 183 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->clock_type_combo;
#line 185 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 185 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 185 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 185 "../src/preferences-dialog.vala"
	model = _tmp3_;
#line 186 "../src/preferences-dialog.vala"
	active_iter_clock_type = _tmp4_;
#line 189 "../src/preferences-dialog.vala"
	_tmp5_ = model;
#line 189 "../src/preferences-dialog.vala"
	_tmp7_ = gtk_tree_model_get_iter_first (_tmp5_, &_tmp6_);
#line 189 "../src/preferences-dialog.vala"
	iter = _tmp6_;
#line 189 "../src/preferences-dialog.vala"
	if (_tmp7_) {
#line 857 "preferences-dialog.c"
		{
			gboolean _tmp8_ = FALSE;
#line 191 "../src/preferences-dialog.vala"
			_tmp8_ = TRUE;
#line 191 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 864 "preferences-dialog.c"
				gint type = 0;
				GtkTreeModel* _tmp11_;
				GtkTreeIter _tmp12_;
				gint _tmp13_ = 0;
#line 191 "../src/preferences-dialog.vala"
				if (!_tmp8_) {
#line 871 "preferences-dialog.c"
					GtkTreeModel* _tmp9_;
					gboolean _tmp10_;
#line 199 "../src/preferences-dialog.vala"
					_tmp9_ = model;
#line 199 "../src/preferences-dialog.vala"
					_tmp10_ = gtk_tree_model_iter_next (_tmp9_, &iter);
#line 199 "../src/preferences-dialog.vala"
					if (!_tmp10_) {
#line 199 "../src/preferences-dialog.vala"
						break;
#line 882 "preferences-dialog.c"
					}
				}
#line 191 "../src/preferences-dialog.vala"
				_tmp8_ = FALSE;
#line 194 "../src/preferences-dialog.vala"
				_tmp11_ = model;
#line 194 "../src/preferences-dialog.vala"
				_tmp12_ = iter;
#line 194 "../src/preferences-dialog.vala"
				gtk_tree_model_get (_tmp11_, &_tmp12_, 1, &_tmp13_, -1, -1);
#line 194 "../src/preferences-dialog.vala"
				type = _tmp13_;
#line 195 "../src/preferences-dialog.vala"
				if (type == clock_type) {
#line 897 "preferences-dialog.c"
					GtkTreeIter _tmp14_;
#line 197 "../src/preferences-dialog.vala"
					_tmp14_ = iter;
#line 197 "../src/preferences-dialog.vala"
					active_iter_clock_type = _tmp14_;
#line 903 "preferences-dialog.c"
				}
			}
		}
	}
#line 202 "../src/preferences-dialog.vala"
	_tmp15_ = self->priv->clock_type_combo;
#line 202 "../src/preferences-dialog.vala"
	_tmp16_ = active_iter_clock_type;
#line 202 "../src/preferences-dialog.vala"
	gtk_combo_box_set_active_iter (_tmp15_, &_tmp16_);
#line 203 "../src/preferences-dialog.vala"
	_tmp17_ = self->priv->clock_type_combo;
#line 203 "../src/preferences-dialog.vala"
	preferences_dialog_clock_type_changed_cb (self, _tmp17_);
#line 183 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 920 "preferences-dialog.c"
}

static void
preferences_dialog_set_timer_increment (PreferencesDialog* self,
                                        gint timer_increment)
{
	gint timer_increment_multiplier = 0;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeIter iter = {0};
	GtkTreeIter reqd_iter = {0};
	GtkTreeIter _tmp6_ = {0};
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_ = {0};
	gboolean _tmp9_;
	GtkComboBox* _tmp17_;
	GtkTreeIter _tmp18_;
	GtkComboBox* _tmp19_;
#line 206 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/preferences-dialog.vala"
	timer_increment_multiplier = 1;
#line 210 "../src/preferences-dialog.vala"
	if (timer_increment >= 60) {
#line 948 "preferences-dialog.c"
		GtkAdjustment* _tmp0_;
#line 212 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->timer_increment_adjustment;
#line 212 "../src/preferences-dialog.vala"
		gtk_adjustment_set_value (_tmp0_, (gdouble) (timer_increment / 60));
#line 213 "../src/preferences-dialog.vala"
		timer_increment_multiplier = 60;
#line 956 "preferences-dialog.c"
	} else {
		GtkAdjustment* _tmp1_;
#line 215 "../src/preferences-dialog.vala"
		_tmp1_ = self->priv->timer_increment_adjustment;
#line 215 "../src/preferences-dialog.vala"
		gtk_adjustment_set_value (_tmp1_, (gdouble) timer_increment);
#line 963 "preferences-dialog.c"
	}
#line 217 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->timer_increment_units_combo;
#line 217 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_combo_box_get_model (_tmp2_);
#line 217 "../src/preferences-dialog.vala"
	_tmp4_ = _tmp3_;
#line 217 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 217 "../src/preferences-dialog.vala"
	model = _tmp5_;
#line 218 "../src/preferences-dialog.vala"
	reqd_iter = _tmp6_;
#line 221 "../src/preferences-dialog.vala"
	_tmp7_ = model;
#line 221 "../src/preferences-dialog.vala"
	_tmp9_ = gtk_tree_model_get_iter_first (_tmp7_, &_tmp8_);
#line 221 "../src/preferences-dialog.vala"
	iter = _tmp8_;
#line 221 "../src/preferences-dialog.vala"
	if (_tmp9_) {
#line 985 "preferences-dialog.c"
		{
			gboolean _tmp10_ = FALSE;
#line 223 "../src/preferences-dialog.vala"
			_tmp10_ = TRUE;
#line 223 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 992 "preferences-dialog.c"
				gint multiplier = 0;
				GtkTreeModel* _tmp13_;
				GtkTreeIter _tmp14_;
				gint _tmp15_ = 0;
#line 223 "../src/preferences-dialog.vala"
				if (!_tmp10_) {
#line 999 "preferences-dialog.c"
					GtkTreeModel* _tmp11_;
					gboolean _tmp12_;
#line 231 "../src/preferences-dialog.vala"
					_tmp11_ = model;
#line 231 "../src/preferences-dialog.vala"
					_tmp12_ = gtk_tree_model_iter_next (_tmp11_, &iter);
#line 231 "../src/preferences-dialog.vala"
					if (!_tmp12_) {
#line 231 "../src/preferences-dialog.vala"
						break;
#line 1010 "preferences-dialog.c"
					}
				}
#line 223 "../src/preferences-dialog.vala"
				_tmp10_ = FALSE;
#line 226 "../src/preferences-dialog.vala"
				_tmp13_ = model;
#line 226 "../src/preferences-dialog.vala"
				_tmp14_ = iter;
#line 226 "../src/preferences-dialog.vala"
				gtk_tree_model_get (_tmp13_, &_tmp14_, 1, &_tmp15_, -1, -1);
#line 226 "../src/preferences-dialog.vala"
				multiplier = _tmp15_;
#line 227 "../src/preferences-dialog.vala"
				if (multiplier == timer_increment_multiplier) {
#line 1025 "preferences-dialog.c"
					GtkTreeIter _tmp16_;
#line 229 "../src/preferences-dialog.vala"
					_tmp16_ = iter;
#line 229 "../src/preferences-dialog.vala"
					reqd_iter = _tmp16_;
#line 1031 "preferences-dialog.c"
				}
			}
		}
	}
#line 234 "../src/preferences-dialog.vala"
	_tmp17_ = self->priv->timer_increment_units_combo;
#line 234 "../src/preferences-dialog.vala"
	_tmp18_ = reqd_iter;
#line 234 "../src/preferences-dialog.vala"
	gtk_combo_box_set_active_iter (_tmp17_, &_tmp18_);
#line 235 "../src/preferences-dialog.vala"
	_tmp19_ = self->priv->timer_increment_units_combo;
#line 235 "../src/preferences-dialog.vala"
	preferences_dialog_timer_increment_units_changed_cb (self, (GtkWidget*) _tmp19_);
#line 206 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 1048 "preferences-dialog.c"
}

static void
preferences_dialog_set_duration (PreferencesDialog* self,
                                 gint duration,
                                 gboolean simplify)
{
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter iter = {0};
	GtkTreeIter max_iter = {0};
	GtkTreeIter _tmp4_ = {0};
	gint max_multiplier = 0;
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean _tmp7_;
	gint value = 0;
	GtkComboBox* _tmp19_;
	GtkTreeModel* _tmp20_;
	GtkTreeModel* _tmp21_;
	GtkTreeModel* _tmp22_;
	GtkTreeModel* _tmp23_;
	GtkTreeIter _tmp24_ = {0};
	gboolean _tmp25_;
#line 238 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->custom_duration_units_combo;
#line 240 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 240 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 240 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 240 "../src/preferences-dialog.vala"
	model = _tmp3_;
#line 241 "../src/preferences-dialog.vala"
	max_iter = _tmp4_;
#line 244 "../src/preferences-dialog.vala"
	max_multiplier = 0;
#line 245 "../src/preferences-dialog.vala"
	_tmp5_ = model;
#line 245 "../src/preferences-dialog.vala"
	_tmp7_ = gtk_tree_model_get_iter_first (_tmp5_, &_tmp6_);
#line 245 "../src/preferences-dialog.vala"
	iter = _tmp6_;
#line 245 "../src/preferences-dialog.vala"
	if (_tmp7_) {
#line 1100 "preferences-dialog.c"
		{
			gboolean _tmp8_ = FALSE;
#line 247 "../src/preferences-dialog.vala"
			_tmp8_ = TRUE;
#line 247 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 1107 "preferences-dialog.c"
				gint multiplier = 0;
				GtkTreeModel* _tmp11_;
				GtkTreeIter _tmp12_;
				gint _tmp13_ = 0;
				gboolean _tmp14_ = FALSE;
#line 247 "../src/preferences-dialog.vala"
				if (!_tmp8_) {
#line 1115 "preferences-dialog.c"
					GtkTreeModel* _tmp9_;
					gboolean _tmp10_;
#line 256 "../src/preferences-dialog.vala"
					_tmp9_ = model;
#line 256 "../src/preferences-dialog.vala"
					_tmp10_ = gtk_tree_model_iter_next (_tmp9_, &iter);
#line 256 "../src/preferences-dialog.vala"
					if (!_tmp10_) {
#line 256 "../src/preferences-dialog.vala"
						break;
#line 1126 "preferences-dialog.c"
					}
				}
#line 247 "../src/preferences-dialog.vala"
				_tmp8_ = FALSE;
#line 250 "../src/preferences-dialog.vala"
				_tmp11_ = model;
#line 250 "../src/preferences-dialog.vala"
				_tmp12_ = iter;
#line 250 "../src/preferences-dialog.vala"
				gtk_tree_model_get (_tmp11_, &_tmp12_, 1, &_tmp13_, -1, -1);
#line 250 "../src/preferences-dialog.vala"
				multiplier = _tmp13_;
#line 251 "../src/preferences-dialog.vala"
				if (multiplier > max_multiplier) {
#line 251 "../src/preferences-dialog.vala"
					_tmp14_ = (duration % multiplier) == 0;
#line 1143 "preferences-dialog.c"
				} else {
#line 251 "../src/preferences-dialog.vala"
					_tmp14_ = FALSE;
#line 1147 "preferences-dialog.c"
				}
#line 251 "../src/preferences-dialog.vala"
				if (_tmp14_) {
#line 1151 "preferences-dialog.c"
					GtkTreeIter _tmp15_;
#line 253 "../src/preferences-dialog.vala"
					max_multiplier = multiplier;
#line 254 "../src/preferences-dialog.vala"
					_tmp15_ = iter;
#line 254 "../src/preferences-dialog.vala"
					max_iter = _tmp15_;
#line 1159 "preferences-dialog.c"
				}
			}
		}
	}
#line 260 "../src/preferences-dialog.vala"
	value = 0;
#line 261 "../src/preferences-dialog.vala"
	if (max_multiplier > 0) {
#line 1168 "preferences-dialog.c"
		GtkAdjustment* _tmp16_;
		GtkComboBox* _tmp17_;
		GtkTreeIter _tmp18_;
#line 263 "../src/preferences-dialog.vala"
		value = duration / max_multiplier;
#line 264 "../src/preferences-dialog.vala"
		_tmp16_ = self->priv->duration_adjustment;
#line 264 "../src/preferences-dialog.vala"
		gtk_adjustment_set_value (_tmp16_, (gdouble) value);
#line 265 "../src/preferences-dialog.vala"
		_tmp17_ = self->priv->custom_duration_units_combo;
#line 265 "../src/preferences-dialog.vala"
		_tmp18_ = max_iter;
#line 265 "../src/preferences-dialog.vala"
		gtk_combo_box_set_active_iter (_tmp17_, &_tmp18_);
#line 1184 "preferences-dialog.c"
	}
#line 268 "../src/preferences-dialog.vala"
	if (!simplify) {
#line 269 "../src/preferences-dialog.vala"
		_g_object_unref0 (model);
#line 269 "../src/preferences-dialog.vala"
		return;
#line 1192 "preferences-dialog.c"
	}
#line 271 "../src/preferences-dialog.vala"
	_tmp19_ = self->priv->duration_combo;
#line 271 "../src/preferences-dialog.vala"
	_tmp20_ = gtk_combo_box_get_model (_tmp19_);
#line 271 "../src/preferences-dialog.vala"
	_tmp21_ = _tmp20_;
#line 271 "../src/preferences-dialog.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 271 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 271 "../src/preferences-dialog.vala"
	model = _tmp22_;
#line 272 "../src/preferences-dialog.vala"
	_tmp23_ = model;
#line 272 "../src/preferences-dialog.vala"
	_tmp25_ = gtk_tree_model_get_iter_first (_tmp23_, &_tmp24_);
#line 272 "../src/preferences-dialog.vala"
	iter = _tmp24_;
#line 272 "../src/preferences-dialog.vala"
	if (!_tmp25_) {
#line 273 "../src/preferences-dialog.vala"
		_g_object_unref0 (model);
#line 273 "../src/preferences-dialog.vala"
		return;
#line 1218 "preferences-dialog.c"
	}
	{
		gboolean _tmp26_ = FALSE;
#line 274 "../src/preferences-dialog.vala"
		_tmp26_ = TRUE;
#line 274 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 1226 "preferences-dialog.c"
			gint v = 0;
			GtkTreeModel* _tmp29_;
			GtkTreeIter _tmp30_;
			gint _tmp31_ = 0;
			gboolean _tmp32_ = FALSE;
#line 274 "../src/preferences-dialog.vala"
			if (!_tmp26_) {
#line 1234 "preferences-dialog.c"
				GtkTreeModel* _tmp27_;
				gboolean _tmp28_;
#line 284 "../src/preferences-dialog.vala"
				_tmp27_ = model;
#line 284 "../src/preferences-dialog.vala"
				_tmp28_ = gtk_tree_model_iter_next (_tmp27_, &iter);
#line 284 "../src/preferences-dialog.vala"
				if (!_tmp28_) {
#line 284 "../src/preferences-dialog.vala"
					break;
#line 1245 "preferences-dialog.c"
				}
			}
#line 274 "../src/preferences-dialog.vala"
			_tmp26_ = FALSE;
#line 277 "../src/preferences-dialog.vala"
			_tmp29_ = model;
#line 277 "../src/preferences-dialog.vala"
			_tmp30_ = iter;
#line 277 "../src/preferences-dialog.vala"
			gtk_tree_model_get (_tmp29_, &_tmp30_, 1, &_tmp31_, -1, -1);
#line 277 "../src/preferences-dialog.vala"
			v = _tmp31_;
#line 278 "../src/preferences-dialog.vala"
			if (v == duration) {
#line 278 "../src/preferences-dialog.vala"
				_tmp32_ = TRUE;
#line 1262 "preferences-dialog.c"
			} else {
#line 278 "../src/preferences-dialog.vala"
				_tmp32_ = v == -1;
#line 1266 "preferences-dialog.c"
			}
#line 278 "../src/preferences-dialog.vala"
			if (_tmp32_) {
#line 1270 "preferences-dialog.c"
				GtkComboBox* _tmp33_;
				GtkTreeIter _tmp34_;
				GtkBox* _tmp35_;
#line 280 "../src/preferences-dialog.vala"
				_tmp33_ = self->priv->duration_combo;
#line 280 "../src/preferences-dialog.vala"
				_tmp34_ = iter;
#line 280 "../src/preferences-dialog.vala"
				gtk_combo_box_set_active_iter (_tmp33_, &_tmp34_);
#line 281 "../src/preferences-dialog.vala"
				_tmp35_ = self->priv->custom_duration_box;
#line 281 "../src/preferences-dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp35_, v == -1);
#line 282 "../src/preferences-dialog.vala"
				_g_object_unref0 (model);
#line 282 "../src/preferences-dialog.vala"
				return;
#line 1288 "preferences-dialog.c"
			}
		}
	}
#line 238 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 1294 "preferences-dialog.c"
}

static gint
preferences_dialog_get_duration (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gint magnitude = 0;
	GtkAdjustment* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gint multiplier = 0;
	GtkComboBox* _tmp11_;
	GtkTreeIter _tmp12_ = {0};
	gboolean _tmp13_;
	gint result = 0;
#line 287 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 290 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->duration_combo;
#line 290 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 290 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 290 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1323 "preferences-dialog.c"
		gint duration = 0;
		GtkComboBox* _tmp3_;
		GtkTreeModel* _tmp4_;
		GtkTreeModel* _tmp5_;
		GtkTreeIter _tmp6_;
		gint _tmp7_ = 0;
#line 293 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->duration_combo;
#line 293 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 293 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 293 "../src/preferences-dialog.vala"
		_tmp6_ = iter;
#line 293 "../src/preferences-dialog.vala"
		gtk_tree_model_get (_tmp5_, &_tmp6_, 1, &_tmp7_, -1, -1);
#line 293 "../src/preferences-dialog.vala"
		duration = _tmp7_;
#line 294 "../src/preferences-dialog.vala"
		if (duration >= 0) {
#line 295 "../src/preferences-dialog.vala"
			result = duration;
#line 295 "../src/preferences-dialog.vala"
			return result;
#line 1348 "preferences-dialog.c"
		}
	}
#line 298 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->duration_adjustment;
#line 298 "../src/preferences-dialog.vala"
	_tmp9_ = gtk_adjustment_get_value (_tmp8_);
#line 298 "../src/preferences-dialog.vala"
	_tmp10_ = _tmp9_;
#line 298 "../src/preferences-dialog.vala"
	magnitude = (gint) _tmp10_;
#line 299 "../src/preferences-dialog.vala"
	multiplier = 1;
#line 300 "../src/preferences-dialog.vala"
	_tmp11_ = self->priv->custom_duration_units_combo;
#line 300 "../src/preferences-dialog.vala"
	_tmp13_ = gtk_combo_box_get_active_iter (_tmp11_, &_tmp12_);
#line 300 "../src/preferences-dialog.vala"
	iter = _tmp12_;
#line 300 "../src/preferences-dialog.vala"
	if (_tmp13_) {
#line 1369 "preferences-dialog.c"
		GtkComboBox* _tmp14_;
		GtkTreeModel* _tmp15_;
		GtkTreeModel* _tmp16_;
		GtkTreeIter _tmp17_;
		gint _tmp18_ = 0;
#line 301 "../src/preferences-dialog.vala"
		_tmp14_ = self->priv->custom_duration_units_combo;
#line 301 "../src/preferences-dialog.vala"
		_tmp15_ = gtk_combo_box_get_model (_tmp14_);
#line 301 "../src/preferences-dialog.vala"
		_tmp16_ = _tmp15_;
#line 301 "../src/preferences-dialog.vala"
		_tmp17_ = iter;
#line 301 "../src/preferences-dialog.vala"
		gtk_tree_model_get (_tmp16_, &_tmp17_, 1, &_tmp18_, -1, -1);
#line 301 "../src/preferences-dialog.vala"
		multiplier = _tmp18_;
#line 1387 "preferences-dialog.c"
	}
#line 303 "../src/preferences-dialog.vala"
	switch (multiplier) {
#line 303 "../src/preferences-dialog.vala"
		case 60:
#line 1393 "preferences-dialog.c"
		{
			GtkAdjustment* _tmp19_;
#line 306 "../src/preferences-dialog.vala"
			_tmp19_ = self->priv->duration_adjustment;
#line 306 "../src/preferences-dialog.vala"
			if (gtk_adjustment_get_upper (_tmp19_) != ((gdouble) 600)) {
#line 1400 "preferences-dialog.c"
				GtkAdjustment* _tmp20_;
#line 307 "../src/preferences-dialog.vala"
				_tmp20_ = self->priv->duration_adjustment;
#line 307 "../src/preferences-dialog.vala"
				gtk_adjustment_set_upper (_tmp20_, (gdouble) 600);
#line 1406 "preferences-dialog.c"
			}
#line 308 "../src/preferences-dialog.vala"
			break;
#line 1410 "preferences-dialog.c"
		}
#line 303 "../src/preferences-dialog.vala"
		case 3600:
#line 1414 "preferences-dialog.c"
		{
			GtkAdjustment* _tmp21_;
#line 310 "../src/preferences-dialog.vala"
			_tmp21_ = self->priv->duration_adjustment;
#line 310 "../src/preferences-dialog.vala"
			if (gtk_adjustment_get_upper (_tmp21_) != ((gdouble) 10)) {
#line 1421 "preferences-dialog.c"
				GtkAdjustment* _tmp22_;
				GtkAdjustment* _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
#line 312 "../src/preferences-dialog.vala"
				_tmp22_ = self->priv->duration_adjustment;
#line 312 "../src/preferences-dialog.vala"
				gtk_adjustment_set_upper (_tmp22_, (gdouble) 10);
#line 313 "../src/preferences-dialog.vala"
				_tmp23_ = self->priv->duration_adjustment;
#line 313 "../src/preferences-dialog.vala"
				_tmp24_ = gtk_adjustment_get_value (_tmp23_);
#line 313 "../src/preferences-dialog.vala"
				_tmp25_ = _tmp24_;
#line 313 "../src/preferences-dialog.vala"
				if (_tmp25_ > ((gdouble) 10)) {
#line 1438 "preferences-dialog.c"
					GtkAdjustment* _tmp26_;
#line 315 "../src/preferences-dialog.vala"
					_tmp26_ = self->priv->duration_adjustment;
#line 315 "../src/preferences-dialog.vala"
					gtk_adjustment_set_value (_tmp26_, (gdouble) 10);
#line 316 "../src/preferences-dialog.vala"
					magnitude = 10;
#line 1446 "preferences-dialog.c"
				}
			}
#line 319 "../src/preferences-dialog.vala"
			break;
#line 1451 "preferences-dialog.c"
		}
		default:
		{
#line 321 "../src/preferences-dialog.vala"
			g_assert_not_reached ();
#line 1457 "preferences-dialog.c"
		}
	}
#line 324 "../src/preferences-dialog.vala"
	result = magnitude * multiplier;
#line 324 "../src/preferences-dialog.vala"
	return result;
#line 1464 "preferences-dialog.c"
}

static void
preferences_dialog_duration_changed_cb (PreferencesDialog* self,
                                        GtkAdjustment* adjustment)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	gboolean _tmp6_;
#line 328 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/preferences-dialog.vala"
	g_return_if_fail (adjustment != NULL);
#line 330 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->custom_duration_units_combo;
#line 330 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 330 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 330 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 330 "../src/preferences-dialog.vala"
	model = _tmp3_;
#line 333 "../src/preferences-dialog.vala"
	_tmp4_ = model;
#line 333 "../src/preferences-dialog.vala"
	_tmp6_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp4_, &_tmp5_);
#line 333 "../src/preferences-dialog.vala"
	iter = _tmp5_;
#line 333 "../src/preferences-dialog.vala"
	if (_tmp6_) {
#line 1502 "preferences-dialog.c"
		{
			gboolean _tmp7_ = FALSE;
#line 335 "../src/preferences-dialog.vala"
			_tmp7_ = TRUE;
#line 335 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 1509 "preferences-dialog.c"
				gint multiplier = 0;
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				gint _tmp12_ = 0;
#line 335 "../src/preferences-dialog.vala"
				if (!_tmp7_) {
#line 1516 "preferences-dialog.c"
					GtkListStore* _tmp8_;
					gboolean _tmp9_;
#line 352 "../src/preferences-dialog.vala"
					_tmp8_ = model;
#line 352 "../src/preferences-dialog.vala"
					_tmp9_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp8_, &iter);
#line 352 "../src/preferences-dialog.vala"
					if (!_tmp9_) {
#line 352 "../src/preferences-dialog.vala"
						break;
#line 1527 "preferences-dialog.c"
					}
				}
#line 335 "../src/preferences-dialog.vala"
				_tmp7_ = FALSE;
#line 338 "../src/preferences-dialog.vala"
				_tmp10_ = model;
#line 338 "../src/preferences-dialog.vala"
				_tmp11_ = iter;
#line 338 "../src/preferences-dialog.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 1, &_tmp12_, -1, -1);
#line 338 "../src/preferences-dialog.vala"
				multiplier = _tmp12_;
#line 339 "../src/preferences-dialog.vala"
				switch (multiplier) {
#line 339 "../src/preferences-dialog.vala"
					case 60:
#line 1544 "preferences-dialog.c"
					{
						GtkListStore* _tmp13_;
						GtkTreeIter _tmp14_;
						gdouble _tmp15_;
						gdouble _tmp16_;
#line 342 "../src/preferences-dialog.vala"
						_tmp13_ = model;
#line 342 "../src/preferences-dialog.vala"
						_tmp14_ = iter;
#line 342 "../src/preferences-dialog.vala"
						_tmp15_ = gtk_adjustment_get_value (adjustment);
#line 342 "../src/preferences-dialog.vala"
						_tmp16_ = _tmp15_;
#line 342 "../src/preferences-dialog.vala"
						gtk_list_store_set (_tmp13_, &_tmp14_, 0, ngettext ("minute", "minutes", (gulong) _tmp16_), -1, -1);
#line 344 "../src/preferences-dialog.vala"
						break;
#line 1562 "preferences-dialog.c"
					}
#line 339 "../src/preferences-dialog.vala"
					case 3600:
#line 1566 "preferences-dialog.c"
					{
						GtkListStore* _tmp17_;
						GtkTreeIter _tmp18_;
						gdouble _tmp19_;
						gdouble _tmp20_;
#line 346 "../src/preferences-dialog.vala"
						_tmp17_ = model;
#line 346 "../src/preferences-dialog.vala"
						_tmp18_ = iter;
#line 346 "../src/preferences-dialog.vala"
						_tmp19_ = gtk_adjustment_get_value (adjustment);
#line 346 "../src/preferences-dialog.vala"
						_tmp20_ = _tmp19_;
#line 346 "../src/preferences-dialog.vala"
						gtk_list_store_set (_tmp17_, &_tmp18_, 0, ngettext ("hour", "hours", (gulong) _tmp20_), -1, -1);
#line 348 "../src/preferences-dialog.vala"
						break;
#line 1584 "preferences-dialog.c"
					}
					default:
					{
#line 350 "../src/preferences-dialog.vala"
						g_assert_not_reached ();
#line 1590 "preferences-dialog.c"
					}
				}
			}
		}
	}
#line 355 "../src/preferences-dialog.vala"
	preferences_dialog_save_duration (self);
#line 328 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 1600 "preferences-dialog.c"
}

static void
_preferences_dialog_duration_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                      gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_duration_changed_cb ((PreferencesDialog*) self, _sender);
#line 1609 "preferences-dialog.c"
}

static void
preferences_dialog_duration_units_changed_cb (PreferencesDialog* self,
                                              GtkWidget* widget)
{
#line 359 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 359 "../src/preferences-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 361 "../src/preferences-dialog.vala"
	preferences_dialog_save_duration (self);
#line 1622 "preferences-dialog.c"
}

static void
_preferences_dialog_duration_units_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_duration_units_changed_cb ((PreferencesDialog*) self, _sender);
#line 1631 "preferences-dialog.c"
}

static void
preferences_dialog_timer_increment_units_changed_cb (PreferencesDialog* self,
                                                     GtkWidget* widget)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	gint multiplier = 0;
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	gboolean _tmp6_;
	GtkComboBox* _tmp23_;
	GtkTreeIter _tmp24_ = {0};
	gboolean _tmp25_;
	GSettings* _tmp39_;
	GtkAdjustment* _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
#line 365 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/preferences-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 367 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->timer_increment_units_combo;
#line 367 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 367 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 367 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 367 "../src/preferences-dialog.vala"
	model = _tmp3_;
#line 369 "../src/preferences-dialog.vala"
	multiplier = 0;
#line 371 "../src/preferences-dialog.vala"
	_tmp4_ = model;
#line 371 "../src/preferences-dialog.vala"
	_tmp6_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp4_, &_tmp5_);
#line 371 "../src/preferences-dialog.vala"
	iter = _tmp5_;
#line 371 "../src/preferences-dialog.vala"
	if (_tmp6_) {
#line 1679 "preferences-dialog.c"
		{
			gboolean _tmp7_ = FALSE;
#line 373 "../src/preferences-dialog.vala"
			_tmp7_ = TRUE;
#line 373 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 1686 "preferences-dialog.c"
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				gint _tmp12_ = 0;
#line 373 "../src/preferences-dialog.vala"
				if (!_tmp7_) {
#line 1692 "preferences-dialog.c"
					GtkListStore* _tmp8_;
					gboolean _tmp9_;
#line 389 "../src/preferences-dialog.vala"
					_tmp8_ = model;
#line 389 "../src/preferences-dialog.vala"
					_tmp9_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp8_, &iter);
#line 389 "../src/preferences-dialog.vala"
					if (!_tmp9_) {
#line 389 "../src/preferences-dialog.vala"
						break;
#line 1703 "preferences-dialog.c"
					}
				}
#line 373 "../src/preferences-dialog.vala"
				_tmp7_ = FALSE;
#line 375 "../src/preferences-dialog.vala"
				_tmp10_ = model;
#line 375 "../src/preferences-dialog.vala"
				_tmp11_ = iter;
#line 375 "../src/preferences-dialog.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 1, &_tmp12_, -1, -1);
#line 375 "../src/preferences-dialog.vala"
				multiplier = _tmp12_;
#line 376 "../src/preferences-dialog.vala"
				switch (multiplier) {
#line 376 "../src/preferences-dialog.vala"
					case 1:
#line 1720 "preferences-dialog.c"
					{
						GtkListStore* _tmp13_;
						GtkTreeIter _tmp14_;
						GtkAdjustment* _tmp15_;
						gdouble _tmp16_;
						gdouble _tmp17_;
#line 379 "../src/preferences-dialog.vala"
						_tmp13_ = model;
#line 379 "../src/preferences-dialog.vala"
						_tmp14_ = iter;
#line 379 "../src/preferences-dialog.vala"
						_tmp15_ = self->priv->timer_increment_adjustment;
#line 379 "../src/preferences-dialog.vala"
						_tmp16_ = gtk_adjustment_get_value (_tmp15_);
#line 379 "../src/preferences-dialog.vala"
						_tmp17_ = _tmp16_;
#line 379 "../src/preferences-dialog.vala"
						gtk_list_store_set (_tmp13_, &_tmp14_, 0, ngettext ("second", "seconds", (gulong) _tmp17_), -1, -1);
#line 381 "../src/preferences-dialog.vala"
						break;
#line 1741 "preferences-dialog.c"
					}
#line 376 "../src/preferences-dialog.vala"
					case 60:
#line 1745 "preferences-dialog.c"
					{
						GtkListStore* _tmp18_;
						GtkTreeIter _tmp19_;
						GtkAdjustment* _tmp20_;
						gdouble _tmp21_;
						gdouble _tmp22_;
#line 383 "../src/preferences-dialog.vala"
						_tmp18_ = model;
#line 383 "../src/preferences-dialog.vala"
						_tmp19_ = iter;
#line 383 "../src/preferences-dialog.vala"
						_tmp20_ = self->priv->timer_increment_adjustment;
#line 383 "../src/preferences-dialog.vala"
						_tmp21_ = gtk_adjustment_get_value (_tmp20_);
#line 383 "../src/preferences-dialog.vala"
						_tmp22_ = _tmp21_;
#line 383 "../src/preferences-dialog.vala"
						gtk_list_store_set (_tmp18_, &_tmp19_, 0, ngettext ("minute", "minutes", (gulong) _tmp22_), -1, -1);
#line 385 "../src/preferences-dialog.vala"
						break;
#line 1766 "preferences-dialog.c"
					}
					default:
					{
#line 387 "../src/preferences-dialog.vala"
						g_assert_not_reached ();
#line 1772 "preferences-dialog.c"
					}
				}
			}
		}
	}
#line 392 "../src/preferences-dialog.vala"
	_tmp23_ = self->priv->timer_increment_units_combo;
#line 392 "../src/preferences-dialog.vala"
	_tmp25_ = gtk_combo_box_get_active_iter (_tmp23_, &_tmp24_);
#line 392 "../src/preferences-dialog.vala"
	iter = _tmp24_;
#line 392 "../src/preferences-dialog.vala"
	if (_tmp25_) {
#line 1786 "preferences-dialog.c"
		GtkComboBox* _tmp26_;
		GtkTreeModel* _tmp27_;
		GtkTreeModel* _tmp28_;
		GtkTreeIter _tmp29_;
		gint _tmp30_ = 0;
#line 393 "../src/preferences-dialog.vala"
		_tmp26_ = self->priv->timer_increment_units_combo;
#line 393 "../src/preferences-dialog.vala"
		_tmp27_ = gtk_combo_box_get_model (_tmp26_);
#line 393 "../src/preferences-dialog.vala"
		_tmp28_ = _tmp27_;
#line 393 "../src/preferences-dialog.vala"
		_tmp29_ = iter;
#line 393 "../src/preferences-dialog.vala"
		gtk_tree_model_get (_tmp28_, &_tmp29_, 1, &_tmp30_, -1, -1);
#line 393 "../src/preferences-dialog.vala"
		multiplier = _tmp30_;
#line 1804 "preferences-dialog.c"
	}
#line 395 "../src/preferences-dialog.vala"
	switch (multiplier) {
#line 395 "../src/preferences-dialog.vala"
		case 1:
#line 1810 "preferences-dialog.c"
		{
			GtkAdjustment* _tmp31_;
#line 398 "../src/preferences-dialog.vala"
			_tmp31_ = self->priv->timer_increment_adjustment;
#line 398 "../src/preferences-dialog.vala"
			if (gtk_adjustment_get_upper (_tmp31_) != ((gdouble) 59)) {
#line 1817 "preferences-dialog.c"
				GtkAdjustment* _tmp32_;
#line 399 "../src/preferences-dialog.vala"
				_tmp32_ = self->priv->timer_increment_adjustment;
#line 399 "../src/preferences-dialog.vala"
				gtk_adjustment_set_upper (_tmp32_, (gdouble) 59);
#line 1823 "preferences-dialog.c"
			}
#line 400 "../src/preferences-dialog.vala"
			break;
#line 1827 "preferences-dialog.c"
		}
#line 395 "../src/preferences-dialog.vala"
		case 60:
#line 1831 "preferences-dialog.c"
		{
			GtkAdjustment* _tmp33_;
#line 402 "../src/preferences-dialog.vala"
			_tmp33_ = self->priv->timer_increment_adjustment;
#line 402 "../src/preferences-dialog.vala"
			if (gtk_adjustment_get_upper (_tmp33_) != ((gdouble) 10)) {
#line 1838 "preferences-dialog.c"
				GtkAdjustment* _tmp34_;
				GtkAdjustment* _tmp35_;
				gdouble _tmp36_;
				gdouble _tmp37_;
#line 404 "../src/preferences-dialog.vala"
				_tmp34_ = self->priv->timer_increment_adjustment;
#line 404 "../src/preferences-dialog.vala"
				gtk_adjustment_set_upper (_tmp34_, (gdouble) 10);
#line 405 "../src/preferences-dialog.vala"
				_tmp35_ = self->priv->timer_increment_adjustment;
#line 405 "../src/preferences-dialog.vala"
				_tmp36_ = gtk_adjustment_get_value (_tmp35_);
#line 405 "../src/preferences-dialog.vala"
				_tmp37_ = _tmp36_;
#line 405 "../src/preferences-dialog.vala"
				if (_tmp37_ > ((gdouble) 10)) {
#line 1855 "preferences-dialog.c"
					GtkAdjustment* _tmp38_;
#line 406 "../src/preferences-dialog.vala"
					_tmp38_ = self->priv->timer_increment_adjustment;
#line 406 "../src/preferences-dialog.vala"
					gtk_adjustment_set_value (_tmp38_, (gdouble) 10);
#line 1861 "preferences-dialog.c"
				}
			}
#line 408 "../src/preferences-dialog.vala"
			break;
#line 1866 "preferences-dialog.c"
		}
		default:
		{
#line 410 "../src/preferences-dialog.vala"
			g_assert_not_reached ();
#line 1872 "preferences-dialog.c"
		}
	}
#line 412 "../src/preferences-dialog.vala"
	_tmp39_ = self->priv->settings;
#line 412 "../src/preferences-dialog.vala"
	_tmp40_ = self->priv->timer_increment_adjustment;
#line 412 "../src/preferences-dialog.vala"
	_tmp41_ = gtk_adjustment_get_value (_tmp40_);
#line 412 "../src/preferences-dialog.vala"
	_tmp42_ = _tmp41_;
#line 412 "../src/preferences-dialog.vala"
	g_settings_set_int (_tmp39_, "timer-increment", ((gint) _tmp42_) * multiplier);
#line 365 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 1887 "preferences-dialog.c"
}

static void
_preferences_dialog_timer_increment_units_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                            gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_timer_increment_units_changed_cb ((PreferencesDialog*) self, _sender);
#line 1896 "preferences-dialog.c"
}

static gboolean
preferences_dialog_save_duration_cb (PreferencesDialog* self)
{
	GSettings* _tmp0_;
	gboolean result = FALSE;
#line 415 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 417 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 417 "../src/preferences-dialog.vala"
	g_settings_set_int (_tmp0_, "duration", preferences_dialog_get_duration (self));
#line 418 "../src/preferences-dialog.vala"
	self->priv->save_duration_timeout = (guint) 0;
#line 419 "../src/preferences-dialog.vala"
	result = G_SOURCE_REMOVE;
#line 419 "../src/preferences-dialog.vala"
	return result;
#line 1916 "preferences-dialog.c"
}

static gboolean
_preferences_dialog_save_duration_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = preferences_dialog_save_duration_cb ((PreferencesDialog*) self);
#line 428 "../src/preferences-dialog.vala"
	return result;
#line 1926 "preferences-dialog.c"
}

static void
preferences_dialog_save_duration (PreferencesDialog* self)
{
#line 422 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/preferences-dialog.vala"
	if (self->priv->save_duration_timeout != ((guint) 0)) {
#line 425 "../src/preferences-dialog.vala"
		g_source_remove (self->priv->save_duration_timeout);
#line 1938 "preferences-dialog.c"
	}
#line 428 "../src/preferences-dialog.vala"
	self->priv->save_duration_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _preferences_dialog_save_duration_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1942 "preferences-dialog.c"
}

static void
preferences_dialog_duration_combo_changed_cb (PreferencesDialog* self,
                                              GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gint duration = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gint _tmp5_ = 0;
	GtkBox* _tmp6_;
	GtkComboBox* _tmp7_;
#line 432 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 432 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 435 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 435 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 435 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 436 "../src/preferences-dialog.vala"
		return;
#line 1971 "preferences-dialog.c"
	}
#line 438 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 438 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 438 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 438 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 438 "../src/preferences-dialog.vala"
	duration = _tmp5_;
#line 439 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->custom_duration_box;
#line 439 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, duration < 0);
#line 440 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->clock_type_combo;
#line 440 "../src/preferences-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, duration != 0);
#line 442 "../src/preferences-dialog.vala"
	if (duration == 0) {
#line 443 "../src/preferences-dialog.vala"
		preferences_dialog_set_clock_type (self, (gint) CLOCK_TYPE_SIMPLE);
#line 1995 "preferences-dialog.c"
	}
#line 445 "../src/preferences-dialog.vala"
	if (duration >= 0) {
#line 446 "../src/preferences-dialog.vala"
		preferences_dialog_set_duration (self, duration, FALSE);
#line 2001 "preferences-dialog.c"
	} else {
#line 448 "../src/preferences-dialog.vala"
		if (preferences_dialog_get_duration (self) <= 0) {
#line 449 "../src/preferences-dialog.vala"
			preferences_dialog_set_duration (self, 60 * 60, FALSE);
#line 2007 "preferences-dialog.c"
		}
	}
#line 451 "../src/preferences-dialog.vala"
	preferences_dialog_save_duration (self);
#line 2012 "preferences-dialog.c"
}

static void
_preferences_dialog_duration_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_duration_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 2021 "preferences-dialog.c"
}

static void
preferences_dialog_clock_type_changed_cb (PreferencesDialog* self,
                                          GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	ClockType clock_type = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	ClockType _tmp5_ = 0;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GSettings* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 455 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 458 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 458 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 458 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 459 "../src/preferences-dialog.vala"
		return;
#line 2053 "preferences-dialog.c"
	}
#line 461 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 461 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 461 "../src/preferences-dialog.vala"
	_tmp4_ = iter;
#line 461 "../src/preferences-dialog.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 461 "../src/preferences-dialog.vala"
	clock_type = _tmp5_;
#line 463 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->timer_increment_box;
#line 463 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, clock_type > 0);
#line 464 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->timer_increment_label;
#line 464 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, clock_type > 0);
#line 465 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->settings;
#line 465 "../src/preferences-dialog.vala"
	_tmp9_ = clock_type_to_string (clock_type);
#line 465 "../src/preferences-dialog.vala"
	_tmp10_ = _tmp9_;
#line 465 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp8_, "clock-type", _tmp10_);
#line 465 "../src/preferences-dialog.vala"
	_g_free0 (_tmp10_);
#line 2083 "preferences-dialog.c"
}

static void
_preferences_dialog_clock_type_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_clock_type_changed_cb ((PreferencesDialog*) self, _sender);
#line 2092 "preferences-dialog.c"
}

static void
preferences_dialog_piece_style_combo_changed_cb (PreferencesDialog* self,
                                                 GtkComboBox* combo)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 469 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 471 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 471 "../src/preferences-dialog.vala"
	_tmp1_ = preferences_dialog_get_combo (self, combo, 1);
#line 471 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 471 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp0_, "piece-theme", _tmp2_);
#line 471 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_);
#line 2116 "preferences-dialog.c"
}

static void
_preferences_dialog_piece_style_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_piece_style_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 2125 "preferences-dialog.c"
}

static void
preferences_dialog_move_format_combo_changed_cb (PreferencesDialog* self,
                                                 GtkComboBox* combo)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 475 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 475 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 477 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 477 "../src/preferences-dialog.vala"
	_tmp1_ = preferences_dialog_get_combo (self, combo, 1);
#line 477 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 477 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp0_, "move-format", _tmp2_);
#line 477 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_);
#line 2149 "preferences-dialog.c"
}

static void
_preferences_dialog_move_format_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_move_format_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 2158 "preferences-dialog.c"
}

static void
preferences_dialog_orientation_combo_changed_cb (PreferencesDialog* self,
                                                 GtkComboBox* combo)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 481 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 483 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 483 "../src/preferences-dialog.vala"
	_tmp1_ = preferences_dialog_get_combo (self, combo, 1);
#line 483 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 483 "../src/preferences-dialog.vala"
	g_settings_set_string (_tmp0_, "board-side", _tmp2_);
#line 483 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_);
#line 2182 "preferences-dialog.c"
}

static void
_preferences_dialog_orientation_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_orientation_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 2191 "preferences-dialog.c"
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Chess/ui/preferences.ui");
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_numbering_check", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, show_numbering_check));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_move_hints_check", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, show_move_hints_check));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "side_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, side_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "difficulty_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, difficulty_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "opponent_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, opponent_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "opponent_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, opponent_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "duration_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, duration_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_increment_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, timer_increment_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_duration_box", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, custom_duration_box));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_increment_box", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, timer_increment_box));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_duration_units_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, custom_duration_units_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_increment_label", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, timer_increment_label));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_increment_units_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, timer_increment_units_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_type_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, clock_type_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "duration_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, duration_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "orientation_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, orientation_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "move_format_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, move_format_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "piece_style_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, piece_style_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "side_combo_changed_cb", G_CALLBACK(_preferences_dialog_side_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "opponent_combo_changed_cb", G_CALLBACK(_preferences_dialog_opponent_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "difficulty_combo_changed_cb", G_CALLBACK(_preferences_dialog_difficulty_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "duration_changed_cb", G_CALLBACK(_preferences_dialog_duration_changed_cb_gtk_adjustment_value_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "duration_units_changed_cb", G_CALLBACK(_preferences_dialog_duration_units_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "timer_increment_units_changed_cb", G_CALLBACK(_preferences_dialog_timer_increment_units_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "duration_combo_changed_cb", G_CALLBACK(_preferences_dialog_duration_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "clock_type_changed_cb", G_CALLBACK(_preferences_dialog_clock_type_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "piece_style_combo_changed_cb", G_CALLBACK(_preferences_dialog_piece_style_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "move_format_combo_changed_cb", G_CALLBACK(_preferences_dialog_move_format_combo_changed_cb_gtk_combo_box_changed));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "orientation_combo_changed_cb", G_CALLBACK(_preferences_dialog_orientation_combo_changed_cb_gtk_combo_box_changed));
#line 2264 "preferences-dialog.c"
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
#line 14 "../src/preferences-dialog.vala"
	self->priv = preferences_dialog_get_instance_private (self);
#line 18 "../src/preferences-dialog.vala"
	self->priv->save_duration_timeout = (guint) 0;
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2277 "preferences-dialog.c"
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
#line 14 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 111 "../src/preferences-dialog.vala"
	if (self->priv->save_duration_timeout != ((guint) 0)) {
#line 113 "../src/preferences-dialog.vala"
		g_source_remove (self->priv->save_duration_timeout);
#line 114 "../src/preferences-dialog.vala"
		preferences_dialog_save_duration_cb (self);
#line 2292 "preferences-dialog.c"
	}
#line 16 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
#line 2298 "preferences-dialog.c"
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}

